/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */
import { HTMLStencilElement, JSXBase } from "./stencil-public-runtime";
import { PnButtonAppearance, PnButtonVariant, PnColors, PnLanguages as PnLanguages1, PnMultiselectOption, PnZipCodeSearchLanguages } from "./index";
import { PnLanguages, PnMarkets, PnSteps, PnUploadFileItem } from "./globals/types";
import { CalendarView, PnDatePickerSelectEvent } from "./globals/date/index";
import { Event } from "./stencil-public-runtime";
export { PnButtonAppearance, PnButtonVariant, PnColors, PnLanguages as PnLanguages1, PnMultiselectOption, PnZipCodeSearchLanguages } from "./index";
export { PnLanguages, PnMarkets, PnSteps, PnUploadFileItem } from "./globals/types";
export { CalendarView, PnDatePickerSelectEvent } from "./globals/date/index";
export { Event } from "./stencil-public-runtime";
export namespace Components {
    /**
     * The `pn-accordion` is a wrapper for `pn-accordion-row` components.
     * This component gives the accordion rows some space between each one and provides the `single` feature.
     * Which will force the rule that only a single row to be open at one time.
     */
    interface PnAccordion {
        /**
          * Only allow a single row to be open at once.
         */
        "single": boolean;
        /**
          * Optional prop that removes the default white background on the accordion row
         */
        "transparent": boolean;
    }
    /**
     * Use this row component inside a `pn-accordion` to create an accordion group.
     * **Note**: you can use the `pn-accordion-row` without the parent accordion.
     * But you will have to style the gap between each row.
     */
    interface PnAccordionRow {
        /**
          * Optional unique id for the `summary` element.
          * @category ID
         */
        "buttonid"?: string;
        /**
          * Optional unique id for the `div` element containing the content.
          * @category ID
         */
        "contentid"?: string;
        /**
          * The label/title of the accordion row, you can also pass a slot with the name "label" if you want to put custom HTML content in there.
         */
        "label": string;
        /**
          * The open/close status of the accordion row.
         */
        "state"?: boolean;
        /**
          * Optional prop that removes the default white background on the accordion row
         */
        "transparent": boolean;
    }
    /**
     * The `pn-button` is built with a native `button` or `a` element, if you use the `href` attribute.
     * @nativeClick Use the `click` event to listen when the button is clicked.
     */
    interface PnButton {
        /**
          * Select the button appearance: default (blue), `light` (white) and  `warning` (red).
          * @category Visual
         */
        "appearance"?: PnButtonAppearance;
        /**
          * HTML aria-controls attribute.
          * @category HTML attributes
         */
        "ariacontrols"?: string;
        /**
          * HTML aria-current attribute.
          * @category HTML attributes
         */
        "ariacurrent"?: string;
        /**
          * HTML aria-expanded attribute.
          * @category HTML attributes
         */
        "ariaexpanded"?: string;
        /**
          * HTML aria-haspopup attribute.
          * @category HTML attributes
         */
        "ariahaspopup"?: string;
        /**
          * HTML aria-label attribute.
          * @category HTML attributes
         */
        "arialabel"?: string;
        /**
          * HTML aria-labelledby attribute.
          * @category HTML attributes
         */
        "arialabelledby"?: string;
        /**
          * HTML aria-pressed attribute.
          * @category HTML attributes
         */
        "ariapressed"?: string;
        /**
          * HTML ID.
          * @category HTML attributes
         */
        "buttonId"?: string;
        /**
          * The download attribute of the link.
          * @category Link
         */
        "download"?: string;
        /**
          * Connect this button to a HTML form.
          * @category Button
          * @see {@link https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#form HTML button form}
         */
        "form"?: string;
        /**
          * Pass an href to make the button into link (a-tag).
          * @category Link
         */
        "href"?: string;
        /**
          * The SVG content of the icon you want.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/docs-assets--docs pn-design-assets}
          * @category Icon
         */
        "icon"?: string;
        /**
          * Turn the button into an icon only. Requires `icon` and one of the following props to work: `tooltip`, `arialabel` or `arialabelledby`.
          * @summary __You need an `icon` selected, as well as either `tooltip`, `arialabel` or `arialabelledby` for this to work__.
          * @see {@link icon }
          * @category Icon
         */
        "iconOnly": boolean;
        /**
          * The label of the button, this is the same as using the default slot.
         */
        "label"?: string;
        /**
          * Place the `icon` to the left of the button.
          * @summary __You need an `icon` selected for this to work__.
          * @see {@link icon }
          * @category Icon
         */
        "leftIcon": boolean;
        /**
          * Display the loading indicator.
          * @category Visual
         */
        "loading": boolean;
        /**
          * HTML tabindex.
          * @category HTML attributes
         */
        "noTab"?: boolean;
        /**
          * The rel attribute of the link.
          * @category Link
         */
        "rel"?: string;
        /**
          * Use the small button.
          * @category Visual
         */
        "small": boolean;
        /**
          * The target attribute of the link.
          * @category Link
         */
        "target"?: string;
        /**
          * When the user focus/hover the button, the `tooltip` text will show up.
          * @category Tooltip
         */
        "tooltip"?: string;
        /**
          * Prefer the tooltip to open upwards. Will still go downwards if there is no space.
          * @category Tooltip
         */
        "tooltipUp": boolean;
        /**
          * Select HTML button type.
          * @category Button
         */
        "type"?: 'button' | 'reset' | 'submit' | '';
        /**
          * Select the button variant: default (colored background), `outlined` (bordered, no background) and `borderless` (borderless, no background).
          * @category Visual
         */
        "variant"?: PnButtonVariant;
    }
    /**
     * The open/closing of the dropdown is handled by the component itself.
     * @nativeClick Use the `click` event to listen when the button is clicked.
     */
    interface PnButtonDropdown {
        /**
          * Select between `light` and `warning`.
         */
        "appearance"?: PnButtonAppearance;
        /**
          * The optional SVG content of the icon you want.
         */
        "icon"?: string;
        /**
          * The required label on the button.
         */
        "label": string;
        /**
          * Open/close the dropdown without user interaction.
         */
        "open": boolean;
        /**
          * Smaller button.
         */
        "small": boolean;
        /**
          * Tooltip (required for Icon Only).
         */
        "tooltip": string;
        /**
          * Select between `outlined` and `borderless`.
         */
        "variant"?: PnButtonVariant;
    }
    /**
     * The card component is more than just a navigational element.
     * It is a flexible component that can be used as a product item, a clickable link card, etc...
     * Setting the `href` prop will transform the entire `pn-card` into a clickable element.
     * If you need content to be interactable inside the card, do not use the `href` prop.
     */
    interface PnCard {
        /**
          * Select image aspect ratio. Example: '3/3', '16/9'.
          * @see {@link https://developer.mozilla.org/en-US/docs/Web/CSS/aspect-ratio CSS documentation.}
          * @category Features
         */
        "aspectRatio"?: string | '3/3' | '16/9';
        /**
          * Set a HTML id for the card. Optional and not required.
         */
        "cardId"?: string;
        /**
          * Uee the horizontal card layout.
          * @category Features
         */
        "horizontal"?: boolean;
        /**
          * The card link.
          * @category Href
         */
        "href"?: string;
        /**
          * The link text.
          * @category Href
         */
        "hrefLabel"?: string;
        /**
          * The link icon. Defaults to `arrow_right` or `open_in_new` if `target="_blank"`.
          * @category Href
         */
        "icon"?: string;
        /**
          * Headline of the card. Will act as label for the link if there is no `href-label` set.
         */
        "label": string;
        /**
          * The label HTML tag. Default is `h3`.
         */
        "labelTag"?: 'h2' | 'h3' | 'h4' | 'h5' | 'h6' | 'p';
        /**
          * Set a smaller text above the `label` text.
         */
        "overline"?: string;
        /**
          * The rel attribute of the link.
          * @category Href
         */
        "rel"?: string;
        /**
          * Reverse the order of which the image will wrap.
          * @category Features
         */
        "reverse"?: boolean;
        /**
          * The target attribute of the link.
          * @category Href
         */
        "target"?: string;
        /**
          * Text content of the card.
         */
        "text"?: string;
    }
    /**
     * The `pn-checkbox` is built with a native `input[type="checkbox"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the checkbox state is being toggled.
     */
    interface PnCheckbox {
        /**
          * A unique HTML ID for the checkbox.
         */
        "checkboxid": string;
        /**
          * Check the radio button.
         */
        "checked": boolean;
        /**
          * Disable the radio button.
          * @category State
         */
        "disabled": boolean;
        /**
          * This adds an optional helpertext element under the label
         */
        "helpertext"?: string;
        /**
          * Add an icon on the right of your checkbox tile. The `tile` prop must be `true` for the icon to work.
          * @category Tile
         */
        "icon"?: string;
        /**
          * Sets the checkbox to an indeterminate state, allowing for a mixed or intermediate checkbox state.
          * @category State
         */
        "indeterminate": boolean;
        /**
          * If set to true, color scheme will turn red, indicating that there is an issue or incorrect input related the checkbox.
          * @category State
         */
        "invalid": boolean;
        /**
          * The checkbox label
         */
        "label"?: string;
        /**
          * The name of the checkbox group
         */
        "name": string;
        /**
          * Set the checkbox as required.
          * @category State
         */
        "required": boolean;
        /**
          * If set to true, this checkbox turns into a checkbox-tile.
          * @category Tile
         */
        "tile": boolean;
        /**
          * This will be emitted on change and input, like a native checkbox
         */
        "value": string;
    }
    /**
     * The `pn-choice-chip` is built with a native `input[type="checkbox|radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the choice chip state is being toggled. Works for both checkbox/radio variant.
     */
    interface PnChoiceChip {
        /**
          * Precheck the choice chip
         */
        "checked"?: boolean;
        /**
          * A unique HTML id
         */
        "choiceid": string;
        /**
          * Disable the choice chip.
          * @category State
         */
        "disabled": boolean;
        /**
          * Include an icon
         */
        "icon"?: string;
        /**
          * The choice chip label
         */
        "label": string;
        /**
          * Set the size to large.
          * @category Size
         */
        "large": boolean;
        /**
          * The name of the checkbox group
         */
        "name"?: string;
        /**
          * Make the choice chip a radio
         */
        "radio": boolean;
        /**
          * Set the choice chip as required.
          * @category State
         */
        "required": boolean;
        /**
          * Set the size to small.
          * @category Size
         */
        "small": boolean;
        /**
          * This will be emitted on change and input
         */
        "value": string;
    }
    /**
     * The `pn-counter` is an input with a button on each side that can be used to increase and decrease the input value.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface PnCounter {
        /**
          * Set a unique HTML ID for the counter
         */
        "counterid": string;
        /**
          * Set the counter as disabled.
          * @category State
         */
        "disabled": boolean;
        /**
          * Set a helpertext for the counter.
         */
        "helpertext"?: string;
        /**
          * Label for the counter
         */
        "label": string;
        /**
          * Text for the decrease button. Default is "Decrease".
          * @category Translation
         */
        "labelDecrease"?: string;
        /**
          * Text for the increase button. Default is "Increase".
          * @category Translation
         */
        "labelIncrease"?: string;
        /**
          * Set the language manually for the built in translations.
         */
        "language"?: PnLanguages;
        /**
          * Suggest values for the counter input.
          * @category HTML input
         */
        "list"?: string;
        /**
          * Maximum value.
          * @category HTML input
         */
        "max": number;
        /**
          * Set a message that shows below input when user wants to set a value that is above `max`. Default is "Maximum value is x"
          * @category Translation
         */
        "maxMessage"?: string;
        /**
          * Minimum value.
          * @category HTML input
         */
        "min": number;
        /**
          * Set a message that shows below input when user wants to set a value that is below `min`. Default is "Minimum value is x"
          * @category Translation
         */
        "minMessage"?: string;
        /**
          * HTML input name.
          * @category HTML input
         */
        "name"?: string;
        /**
          * Set the counter as readonly.
          * @category State
         */
        "readonly": boolean;
        /**
          * Set the counter as required.
          * @category State
         */
        "required": boolean;
        /**
          * Increase/decrease the value in steps, default is 1.
          * @category HTML input
         */
        "step": number;
        /**
          * Set a predefined value
         */
        "value": number;
    }
    /**
     * The date picker allows a single or a range of dates to be selected.
     * Based on the `format` prop, separators will automatically be added if you type the date.
     * You can navigate the calendar grid with your keyboard.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface PnDatePicker {
        /**
          * Set the input `autocomplete` attribute.
          * @category HTML attributes
         */
        "autocomplete"?: string;
        /**
          * Make the calendar open upwards by default. Opens downwards if there is not enough space.
          * @category Features
         */
        "calendarUp": boolean;
        /**
          * Set a custom ID for the calendar.
          * @category HTML attributes
         */
        "dateId": string;
        /**
          * If you use a format with an unknown length, disable the max length.
          * @category Features
         */
        "disableMaxLength"?: boolean;
        /**
          * Disable the automatic insertion of separators when typing in the input.
          * @category Features
         */
        "disableTypeAhead": boolean;
        /**
          * Remove the option to select dates on weekends.
          * @category Features
         */
        "disableWeekends": boolean;
        /**
          * Set the date picker as disabled.
          * @category State
         */
        "disabled": boolean;
        /**
          * Individual dates you want to disable. Use a comma separated string.  Remember to use the same format that you have in the `format` prop.
          * @see {@link format }
          * @example "YYYY-MM-DD,YYYY-MM-DD"
          * @category Features
         */
        "disabledDates"?: string;
        /**
          * Set a predefined value for the from date.
          * @see {@link range }
          * @see {@link format }
         */
        "end": string;
        /**
          * Placeholder for end date (defaults to the format prop).
          * @see {@link format }
          * @category HTML attributes
         */
        "endPlaceholder"?: string;
        /**
          * Set an error message for the date picker. Overwrites the helpertext if used at the same time.
          * @category Validation
         */
        "error"?: string;
        /**
          * Set the date format of the value.  While you can set any date value from the Dayjs documentation, we strongly recommend you pick a simple format that you can also type manually.
          * @see {@link https://day.js.org/docs/en/display/format Day.js format documentation.}
         */
        "format": string;
        /**
          * Provide a helpertext for the date input.
         */
        "helpertext"?: string;
        /**
          * Trigger the invalid state without an error message.
          * @category Validation
         */
        "invalid": boolean;
        /**
          * Set a label for the from date.
         */
        "labelFrom": string;
        /**
          * Set a label for the to date.
          * @see {@link range }
         */
        "labelTo"?: string;
        /**
          * Manually set language; this will be inherited from the topbar.
         */
        "language"?: PnLanguages;
        /**
          * Set the input `list` attribute for the first date input.
          * @category HTML attributes
         */
        "list"?: string;
        /**
          * Set the input `list` attribute for the second date input.
          * @category HTML attributes
         */
        "listEnd"?: string;
        /**
          * Latest date possible, this will determine how many years forward the date picker will show.  Remember to use the same format that you have in the `format` prop.
          * @see {@link format }
          * @example "2024-06-25"
          * @category Min/max date
         */
        "maxDate"?: string;
        /**
          * Earliest date possible, this will determine how many years back the date picker will show.  Remember to use the same format that you have in the `format` prop.
          * @see {@link format }
          * @example "2024-05-25"
          * @category Min/max date
         */
        "minDate"?: string;
        /**
          * HTML input name
          * @category HTML attributes
         */
        "name"?: string;
        /**
          * Set the HTML pattern prop on the input elements. Make sure it matches the format.
          * @category HTML attributes
         */
        "pattern"?: string;
        /**
          * Placeholder for the input field (defaults to the format prop).
          * @see {@link format }
          * @category HTML attributes
         */
        "placeholder"?: string;
        /**
          * Allow the selection of a date range.
          * @category Features
         */
        "range": boolean;
        /**
          * Set a limit on how many days one may select. By default, you can select an unlimited range.
          * @todo Create a range limit function.
          * @see {@link range }
          * @category Features
          * @hide true
         */
        "rangeLimit"?: number;
        /**
          * Set the date picker as readonly.
          * @category State
         */
        "readonly": boolean;
        /**
          * Set the date picker as required.
          * @category State
         */
        "required": boolean;
        /**
          * Set a predefined value for the from date.
          * @see {@link format }
         */
        "start": string;
        /**
          * The calendar grid is shown as default. You can set either `months` or `years` as your first choice.
          * @category Features
         */
        "view": CalendarView;
        /**
          * Show weekend numbers to the left of the calendar grid.
          * @category Features
         */
        "weekNumbers": boolean;
    }
    /**
     * The fielset is a wrapper to give context and information about inputs. Most commonly, a set of radio/checkboxes.
     * However, you may include any type of input such as textareas, toggles and selects.
     */
    interface PnFieldset {
        /**
          * Disable all of the inputs inside of the fieldset.
         */
        "disabled": boolean;
        /**
          * Error message, applies warning styles and icon.
         */
        "error"?: string;
        /**
          * Give the fieldset a custom HTML id.
         */
        "fieldsetId": string;
        /**
          * The id of the form you want the fieldset to be part of. If you want the inputs inside to be associated with a specific form, you need to set on those elements directly.
         */
        "form"?: string;
        /**
          * Text message underneath the legend for more instruction or hints on how to fill in controls correctly.
         */
        "helpertext"?: string;
        /**
          * Set the fieldset as `invalid`, will add red error styles.
         */
        "invalid": boolean;
        /**
          * The legend provides a caption for the fieldset group. This should be a question or heading that describes the inputs/fields.
         */
        "legend": string;
        /**
          * Give the fieldset a HTML name.
         */
        "name"?: string;
    }
    /**
     * Users can drop files directly into the upload area of the component
     * or simply click on it to open their native file explorer.
     * @nativeChange Use the `change` event to listen when the input receives files.
     * @nativeCancel The `cancel` event lets you know the user canceled their selection.
     * Either via clicking on the "Cancel" button or pressing `ESC`.
     */
    interface PnFileUpload {
        /**
          * Set which file types the input accepts. Ex: .docs,.xml
          * @category HTML attributes
         */
        "accept": string;
        /**
          * Use the capture mode.
          * @category HTML attributes
         */
        "capture"?: '' | 'user' | 'environment';
        /**
          * Clear the selected files, state and input value.
         */
        "clearUpload": () => Promise<void>;
        /**
          * Disable the input.
          * @category HTML attributes
         */
        "disabled": boolean;
        /**
          * The helpertext defaults to "Supported formats {x} and max filesize {y}", if there is a value set for the prop `accept`.
         */
        "helpertext"?: string;
        /**
          * Always hide the progress bar, even when upload has begun.
          * @category Features
         */
        "hideProgress": boolean;
        /**
          * The default label is "Click or drag a file here".
         */
        "label"?: string;
        /**
          * Manually set the language.
          * @category Features
         */
        "language"?: PnLanguages;
        /**
          * Set maximum amount of files to be selected. Any value above 1 will force the `multiple` to be `true`.
          * @category HTML attributes
         */
        "limit": number;
        /**
          * Set the maximum upload size.
          * @category HTML attributes
         */
        "maxSize": string;
        /**
          * Allow multiple files to be selected. Will be overwritten to true, if `limit` is above 1.
          * @category HTML attributes
         */
        "multiple": boolean;
        /**
          * Set a HTML name.
          * @category HTML attributes
         */
        "name": string;
        /**
          * Remove the selected file.
         */
        "removeFile": (targetFile: PnUploadFileItem) => Promise<void>;
        /**
          * Set the input as required.
          * @category HTML attributes
         */
        "required"?: boolean;
        /**
          * Start the upload of all selected files (excludes invalid files).
         */
        "startUpload": () => Promise<void>;
        /**
          * Update an existing file.
         */
        "updateFile": (file: PnUploadFileItem, index?: any) => Promise<void>;
    }
    /**
     * The default market and language is SE/en.
     * Make sure you set the market **and** language prop.
     * Example: Setting the `language` prop `da` will not display anything, as `da` does not exist on the `SE` market.
     * @deprecated This component has been replaced with the {@link https://portal.postnord.com/web-components/?path=/docs/external-components-pn-footer-nav--docs pn-footer-nav}.
     */
    interface PnFooter {
        /**
          * Set the language for the footer.
         */
        "language"?: PnLanguages;
        /**
          * Set the market for the footer.
         */
        "market"?: PnMarkets;
    }
    interface PnHeader {
        /**
          * The href for the go back link. If this is provided a button be displayed.
         */
        "goBackHref"?: string;
        /**
          * The text for the back link.
         */
        "goBackText"?: string;
        /**
          * Heading text.
         */
        "heading": string;
        /**
          * Set the language manually, only use this prop if the pnTopbar is not loaded. Supported: sv, en, da, fi and no.
         */
        "language"?: PnLanguages;
        /**
          * Set a inner container max-width, any width CSS value is accepted.
         */
        "maxWidth"?: string;
    }
    /**
     * The `pn-icon` is a wrapper for an SVG string.
     * While its built with PostNords specific icon dimensions in mind (24x24px), you can use any SVG content in this component.
     * As long as its 3x3 in size, there should be no problem.
     * The color feature will not overwrite the color of flags.
     */
    interface PnIcon {
        /**
          * Color the icon with one of the follwing colors from our library.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-design-tokens-colors--docs PostNord Colors (Storybook)}
         */
        "color"?: PnColors;
        /**
          * The SVG content of the icon you want to use.  Flags cannot be colored.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-design-tokens-icon--docs PostNord Icons (Storybook)}
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-design-tokens-flag--docs PostNord Flags (Storybook)}
         */
        "icon": string;
        /**
          * Make the icon small (16 instead of 24px).
         */
        "small": boolean;
    }
    interface PnIllustration {
        /**
          * Make the SVG fill to its parent size (sets width/height 100% and `display: block` instead of `inline-block`)
         */
        "fill"?: boolean;
        /**
          * Set the height of the SVG element. Any valid CSS height value is allowed
         */
        "height"?: string;
        /**
          * The SVG content of the illustration you want to use. The viewBox property will be used to determine width/height
         */
        "illustration": string;
        /**
          * Set the width of the SVG element. Any valid CSS width value is allowed
         */
        "width"?: string;
    }
    /**
     * The `pn-input` is a regular `input` but styled. This means you can use native events to listen to the changes.
     * Always use the `label` prop to make sure the input is accessible.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface PnInput {
        /**
          * Set the ID of what this input controls.
          * @category HTML input
         */
        "ariacontrols"?: string;
        /**
          * While you can use the `aria-label`, using a `label` is far more accessible.
          * @category HTML input
         */
        "arialabel"?: string;
        /**
          * Let the browser know what type of autocorrects the input should use. Works much better if a `name` and `inputid` is supplied.
          * @see {@link name }
          * @see {@link inputid }
          * @category HTML input
         */
        "autocomplete"?: string;
        /**
          * Set the input as `disabled`.
          * @category State
         */
        "disabled": boolean;
        /**
          * Set the input as `invalid` and display an error message (applies the same style as `invalid`).  Error message; will take precedence over helpertext if both are provided.
          * @see {@link invalid Set invalid without an error message.}
          * @category Validation
         */
        "error"?: string;
        /**
          * Text message placed underneath the input field.
         */
        "helpertext"?: string;
        /**
          * Select an icon to display before the input field value. `icon` takes precedence over the `text-prefix` prop.
          * @see {@link textPrefix }
          * @category Visual
         */
        "icon": string;
        /**
          * Provide a unique HTML id to connect the input with the label. A unique uuid ID will be generated if this field is left empty.
         */
        "inputid": string;
        /**
          * Hint the browser about what type of virtual keyboard should be used. The browser will be able to decide this on its own most of the time, especially if you use the `type`, `name` and `inputid` props.  Leave empty or with a `''` value if you want the browsers default behaviour (`text`).
          * @category HTML input
         */
        "inputmode"?: 'text' | 'none' | 'decimal' | 'numeric' | 'tel' | 'search' | 'email' | 'url';
        /**
          * Set the input as `invalid`. Provides a red color and red warning icon.
          * @see {@link error Provide an error message.}
          * @category Validation
         */
        "invalid": boolean;
        /**
          * Text label placed above the input field.
         */
        "label": string;
        /**
          * Set the language manually for the translations of show/hide/clear button text. Not needed if you have the pntopbar on the page.
         */
        "language"?: PnLanguages;
        /**
          * Point to a datalist element for this input.
          * @category HTML input
         */
        "list"?: string;
        /**
          * Set the `max` value of the `number` input.
          * @category HTML input
         */
        "max"?: number | string;
        /**
          * The maximum number of characters the user should be able to add, also adds a visible counter.
          * @category HTML input
         */
        "maxlength": number;
        /**
          * Set the `min` value of the `number` input.
          * @category HTML input
         */
        "min"?: number | string;
        /**
          * HTML input name. Setting a name will help the browser understand what type of data the input have and can better assist with autofill data based on previous entires much better.
          * @category HTML input
         */
        "name"?: string;
        /**
          * Pattern prop.
          * @category HTML input
         */
        "pattern"?: string;
        /**
          * Provide a placeholder text. Remember that this is no replacement for a label. The placeholder should be a nice addition to the label/helpertext, not important information.
          * @category HTML input
         */
        "placeholder"?: string;
        /**
          * Set the input as `readonly`.
          * @category State
         */
        "readonly": boolean;
        /**
          * Set the input as `required`.
          * @category State
         */
        "required": boolean;
        /**
          * Set a `step` for the number input.
          * @category HTML input
         */
        "step"?: number | string;
        /**
          * Set a small text before the input field value. Cannot be used together with an `icon` at the same time.
          * @see {@link icon }
          * @see {@link textSuffix }
          * @category Visual
         */
        "textPrefix": string;
        /**
          * Set a small text after the input field value. Cannot be used with the `text-prefix` prop at the same time.
          * @see {@link textPrefix }
          * @category Visual
         */
        "textSuffix": string;
        /**
          * pn-input supports: `text`, `password`, `url`, `tel`, `search`, `number` & `email`.
          * @category HTML input
         */
        "type"?: 'text' | 'password' | 'url' | 'tel' | 'search' | 'number' | 'email' | '';
        /**
          * Set the input as `valid`. Provides a green color and a check icon.
          * @category Validation
         */
        "valid"?: boolean;
        /**
          * Set the value of the input.
         */
        "value": string;
    }
    /**
     * Present content in a modal that overlays everything on the current page.
     * Use the prop `open` to toggle the visiblity.
     * Use the event `close` to determine when the modal is being closed by the user.
     */
    interface PnModal {
        /**
          * Bind to this property if you want to control the visibility of the modal from your own data.
         */
        "open": boolean;
    }
    /**
     * The `pn-multiselect` gets its options via javascript.
     * Native HTML does not accept arrays of objects. Most frameworks solves this automatically (Vue, react, etc...),
     * but keep this in mind if you use this component outside of a framework environment.
     * @nativeChange The `pn-multiselect` is built with `input[type=checkbox]` elements, so the `change` event works. However, we recommend the customEvents described above.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-input-multiselect--docs#pn-multiselect%20(options) Options documentation}
     */
    interface PnMultiselect {
        /**
          * Set a custom value for the "Select all value" option.
          * @see {@link selectAll }
          * @category Features
         */
        "allValue"?: string;
        /**
          * Force the dropdown to always open downwards.
          * @category Features
         */
        "bottom"?: boolean;
        /**
          * Disable the select.
          * @category Validation
         */
        "disabled"?: boolean;
        /**
          * Display an error message and trigger the invalid state.
          * @category Validation
         */
        "error"?: string;
        /**
          * Display a helper text underneath the select
         */
        "helpertext"?: string;
        /**
          * Display an icon to the left of the select input
         */
        "icon"?: string;
        /**
          * Trigger the invalid state.
          * @category Validation
         */
        "invalid"?: boolean;
        /**
          * Decide how many items should be shown before ellipsis. Requires the `search` prop to work.
          * @see {@link search }
          * @category Features
         */
        "itemCount": number;
        /**
          * Label placed above the select
         */
        "label": string;
        /**
          * Manually set the language, not needed if you have the pnTopbar available
         */
        "language"?: PnLanguages;
        /**
          * Use a custom max-height for the dropdown list.
          * @description The component will automatically set the max height of the dropdown list on its own. It takes the `pn-topbar` into account and will open in the direction that fits best. Use this prop to override this behaviour and use a custom max-height.
          * @category Features
         */
        "maxHeight"?: string;
        /**
          * HTML name of the checkbox elements. Used for each checkbox inside the multiselect.
         */
        "name"?: string;
        /**
          * Array of options.
          * @hide true
         */
        "options": PnMultiselectOption[];
        /**
          * This is what will be shown on load if no value is used. The `placeholder` will override the default text used if you have the `search` prop active.
         */
        "placeholder"?: string;
        /**
          * Set the select as required.
          * @category Validation
         */
        "required"?: boolean;
        /**
          * Allow the user to search among the options. The selected options will now display underneath the multiselect element.
          * @category Features
         */
        "search"?: boolean;
        /**
          * Set the search query of the multiselect.
          * @see {@link search }
          * @category Features
         */
        "searchQuery"?: string;
        /**
          * Adds a "Select all" option into the list. If you use the search feature at the same time, clicking this option will only toggle the options found.
          * @see {@link search }
          * @category Features
         */
        "selectAll": boolean;
        /**
          * Select HTML id
         */
        "selectId": string;
        /**
          * HTML name of the input element.
         */
        "selectName"?: string;
        /**
          * Force the dropdown to always open upwards.
          * @category Features
         */
        "top"?: boolean;
    }
    interface PnOcrSearch {
        /**
          * The `language` property will be prioritized before the pnTopbar language.
         */
        "language"?: PnLanguages;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface PnPageNav {
        /**
          * Pass a string which will be the text on the dropdown button.
         */
        "dropdown": string | boolean;
        /**
          * Set a unique HTML ID.
         */
        "navid": string;
        /**
          * Currently active menu item value
         */
        "value": string;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface PnPageNavDropdownItem {
        /**
          * Ignore this, it's internal communication with parent.
          * @hide true
         */
        "active": boolean;
        /**
          * Pass an href to the items if you want to have links that lead outside of your app
         */
        "href": string;
        /**
          * The value that will be emitted upon selection, only pass this if the item is a link, if you want a button (for quick actions), omit this prop.
         */
        "value": string;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface PnPageNavItem {
        /**
          * Pass an href to the items if you want to have links that lead outside of your app.
         */
        "href": string;
        /**
          * The SVG content of the icon you want.
         */
        "icon": string;
        /**
          * The item value. Used by `pn-page-nav` to determine pre-selected item.
         */
        "value": string;
    }
    /**
     * Accessible pagination needs each item to link to a different part of the document.
     * This means that you must `preventDefault` on the `MouseEvent` emitted from the `pageSelected` event if you have a SPA.
     * If you set a `page` value that is higher than `pages`, the component will automatically lower it to the `pages` value.
     */
    interface PnPagination {
        /**
          * Set a label for the pagination element for screen readers. It defaults to `Pagination`.
         */
        "label"?: string;
        /**
          * Manually set the language.
         */
        "language"?: PnLanguages;
        /**
          * Set which page the user is currently viewing. Use this to set an inital page or if the selected page is changed from outside this component.
          * @category Pages
         */
        "page": number;
        /**
          * Set how many pages are available.
          * @category Pages
         */
        "pages": number;
        /**
          * Set how many pages should be visible at one time. Use an odd number. Minimum is `5`.
          * @category Pages
         */
        "pagesVisible": number;
        /**
          * Set a HTML id on the pagination element.
         */
        "paginationId"?: string;
        /**
          * Allow the user to decide how many items should be shown per page. Make sure this value exists in the `rowsList` string.
          * @see {@link rowsList }
          * @category Rows per page
         */
        "rows": number;
        /**
          * Default label is "Items per page".
          * @see {@link rows }
          * @category Rows per page
         */
        "rowsLabel": string;
        /**
          * Set available items per page options the user can select. Use a comma separated string.
          * @see {@link rows }
          * @category Rows per page
         */
        "rowsList": string;
        /**
          * Set a custom URL template. Use `{page}` within the string to position where the dynamic page number should be.
         */
        "urlTemplate": string;
    }
    interface PnProgressBar {
        /**
          * Trigger an error and display a message
         */
        "error"?: string;
        /**
          * Set a label for the progress bar
         */
        "label"?: string;
        /**
          * Progress value, 0-100
         */
        "progress": number;
        /**
          * A unique HTML id fror the progress bar
         */
        "progressId": string;
        /**
          * Replaces the default progress percentage text
         */
        "progressText"?: string;
        /**
          * Text shown on success (100%)
         */
        "successText"?: string;
    }
    interface PnProgressIndicator {
        /**
          * Takes the index of the active step
         */
        "activeStep": number;
    }
    interface PnProgressIndicatorStep {
        /**
          * Set by the parent component. Do not use manually.
          * @hide true
         */
        "active"?: 'yes' | 'no';
        /**
          * Set by the parent component. Do not use manually.
          * @hide true
         */
        "activeStep": number;
        /**
          * Set the step as checked, meaning a white check mark will appear.
         */
        "checked": boolean;
        /**
          * Set by the parent component. Do not use manually.
          * @hide true
         */
        "index": number;
        /**
          * The step name.
         */
        "name": string;
    }
    /**
     * The `pn-progress-stepper` is used to visualize the users progress through a flow (checkout/survey, etc...).
     */
    interface PnProgressStepper {
        /**
          * The current step of the progress stepper.
         */
        "currentStep": PnSteps;
        /**
          * Set custom label for the stepper, recommended default label is "Step".
         */
        "label"?: string;
        /**
          * Set the language manually, only use this prop if the pnTopbar is not loaded. Will not overwrite the `label` prop if used.
         */
        "language"?: PnLanguages;
        /**
          * Set a custom HTML id on the progress stepper element to associate progress bar with label.
         */
        "progressStepperId"?: string;
        /**
          * You can add a custom optional string to the label if you need a name for the current step.
         */
        "stepName"?: string;
        /**
          * Set total amount of steps, maximum `7` is allowed.
         */
        "totalSteps": PnSteps;
    }
    /**
     * The `pn-radio-button` is built with a native `input[type="radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the radio state is being changed.
     */
    interface PnRadioButton {
        /**
          * Check the radio button
         */
        "checked": boolean;
        /**
          * Disable the radio button.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * With this prop you can add an optional helper text element to radio button.
         */
        "helpertext"?: string;
        /**
          * Add an icon on the right of your radio tile. The `tile` prop must be `true` for the icon to work.
          * @category Tile
         */
        "icon"?: string;
        /**
          * Trigger the red error state.
          * @category State
         */
        "invalid"?: boolean;
        /**
          * The radio button label
         */
        "label"?: string;
        /**
          * The name of the radio button group that will hold this button, like a native radio button (required)
         */
        "name": string;
        /**
          * Give the radio button a custom ID
         */
        "radioid": string;
        /**
          * Set the radio button as required.
          * @category State
         */
        "required"?: boolean;
        /**
          * Turn this radio-button into a radio-tile.
          * @category Tile
         */
        "tile"?: boolean;
        /**
          * This will be emitted on `change` and `input`, like a native radio button (required)
         */
        "value": string;
    }
    /**
     * There are no events or features other than the `icon`, `small` and `language` prop.
     * Our rule is to not have disabled buttons.
     * However, this component is an exception for a very specific use case regarding portal users.
     */
    interface PnReadOnlyButton {
        /**
          * The SVG content of the icon you want.
         */
        "icon"?: string;
        /**
          * If you're using a button with only an icon, button text is still REQUIRED for the tooltip.
         */
        "iconOnly": boolean;
        /**
          * Set the language manually.
         */
        "language"?: PnLanguages;
        /**
          * Icon on the left side instead of on the right.
         */
        "leftIcon": boolean;
        /**
          * Smaller button.
         */
        "small": boolean;
    }
    interface PnSearchField {
        /**
          * Allow the browser to autocomplete the search field.
         */
        "autocomplete"?: string;
        /**
          * Button type, options are `none` for no button, `icon` for a labelless button with just a search icon and `icon-inline` for a search button inside of the search field (this last option disables the clear field button).
          * @category Button
         */
        "button": '' | 'none' | 'icon' | 'icon-inline';
        /**
          * Label for the button element.
          * @category Button
         */
        "buttonLabel"?: string;
        /**
          * Light instead of dark search button.
          * @category Button
         */
        "buttonLight": boolean;
        /**
          * Disable the search field.
          * @category State
         */
        "disabled": boolean;
        /**
          * Provide an aria-label for the search field.
         */
        "label": string;
        /**
          * Override the pntopbar language.
         */
        "language"?: PnLanguages;
        /**
          * Point to a datalist element with this id.
         */
        "list"?: string;
        /**
          * Display loading animation.
          * @category State
         */
        "loading": boolean;
        /**
          * Set HTML name of the search input.
         */
        "name"?: string;
        /**
          * Set a search field placeholder.
         */
        "placeholder"?: string;
        /**
          * Set the search field as required.
          * @category State
         */
        "required": boolean;
        /**
          * Set a unique ID for the search input
         */
        "searchid": string;
        /**
          * Set the value of the search field.
         */
        "value": string;
    }
    /**
     * The `pn-segment` is built with a native `input[type="radio"]` in the background.
     * Do not listen to events on the `pn-segment`, but on the `pn-segmented-control` instead.
     */
    interface PnSegment {
        /**
          * Disable the segment.
         */
        "disabled": boolean;
        /**
          * The SVG content of the icon you want.
         */
        "icon"?: string;
        /**
          * The segment label, same as the slot.
         */
        "label"?: string;
        /**
          * The segment controller name.
         */
        "name": string;
        /**
          * A unique HTML id.
         */
        "segmentid": string;
        /**
          * Set the segment as selected. Used by the `pn-segmented-control`. **Do not use manually**.
          * @hide true
         */
        "selected": boolean;
        /**
          * The segment value.
         */
        "value": string;
    }
    /**
     * The `pn-segmented-control` and `pn-segmented` is built with native `input[type="radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the segment state is being changed.
     */
    interface PnSegmentedControl {
        /**
          * This is the name of the radio buttons inside the controller.
          * @deprecated Set the name in the nested `pn-segment` components.
         */
        "name": string;
        /**
          * Currently active segment value.
         */
        "value": string;
    }
    /**
     * The `pn-select` uses a native `select` element under the hood.
     * Use the slot to include `option` elements.
     * Just like a regular `select`, you can use the `selected` prop on the nested option elements to preselect an option.
     * @nativeChange Use the `change` event to listen to changes on the select element.
     */
    interface PnSelect {
        /**
          * HTML autocomplete.
          * @category HTML
         */
        "autocomplete": string;
        /**
          * Disable the select.
          * @category Validation
         */
        "disabled"?: boolean;
        /**
          * Display an error message and trigger the invalid state.
          * @category Validation
         */
        "error"?: string;
        /**
          * HTML form name.
          * @category HTML
         */
        "form": string;
        /**
          * Display a helper text underneath the select.
         */
        "helpertext"?: string;
        /**
          * Display an icon to the left of the select input.
         */
        "icon"?: string;
        /**
          * Trigger the invalid state.
          * @category Validation
         */
        "invalid"?: boolean;
        /**
          * Label placed above the select.
         */
        "label": string;
        /**
          * HTML select name.
          * @category HTML
         */
        "name": string;
        /**
          * Set the select as required.
          * @category Validation
         */
        "required"?: boolean;
        /**
          * Select HTML id
         */
        "selectId": string;
    }
    interface PnSpinner {
        /**
          * Light version of the spinner
         */
        "light": boolean;
        /**
          * Size in em
         */
        "size": number;
    }
    interface PnTab {
        /**
          * Is set by `pn-tablist`, don't use this prop.
          * @hide true
         */
        "activeTab": string;
        /**
          * Use the ID of the container that this tab controls.
         */
        "ariacontrols"?: string;
        /**
          * Turns the tab from a `button` to an `a` element, but only if the `pn-tablist` is inside a `pn-header`.
         */
        "href"?: string;
        /**
          * The SVG content of the icon you want to display
         */
        "icon"?: string;
        /**
          * Set a label for the tab.
         */
        "label": string;
        /**
          * Tab ID, use if you want to have the tab container be `aria-labelledby` by this tab.
         */
        "tabid"?: string;
        /**
          * This is the value that will be matched with `pn-tablist` value. (required)
         */
        "value": string;
    }
    /**
     * The `pn-table` component is just a wrapper for your HTML table element.
     * You need to create the markup, but the component will deal with the styling.
     * We have a built in class for divs inside table colums called `column-wrapper`.
     * This will line up your content and provide a grid gap.
     */
    interface PnTable {
        /**
          * Add border to table.
         */
        "bordered": boolean;
        /**
          * Use the gray variant instead of blue.
         */
        "gray": boolean;
        /**
          * Make the table striped.
         */
        "striped": boolean;
    }
    interface PnTablist {
        /**
          * Give the tablist a name for screenreaders
         */
        "label": string;
        /**
          * Manually set the language.
         */
        "language"?: PnLanguages;
        /**
          * Make the tablist smaller
         */
        "small"?: boolean;
        /**
          * Icons are stacked vertically instead of the default rows
         */
        "stackedicons": boolean;
        /**
          * The value of the tab that is currently active, each `<pn-tab value="example-value">` also expects a unique value
         */
        "value": string;
    }
    /**
     * The `pn-tag` is a non-interactive visual marker designed to emphasize important aspects of an item, such as its status.
     */
    interface PnTag {
        /**
          * Set tag appearance: `discrete`, `positive`, `warning` & `error`.
          * @category Visual
         */
        "appearance"?: '' | 'discrete' | 'positive' | 'warning' | 'error';
        /**
          * Set darker background-color on the tag.  This is intended for better tag visibility on colored background.
          * @category Visual
          * @deprecated Will be removed in v8.0.0
         */
        "dark"?: boolean;
        /**
          * Select icon from out `pn-design-assets` list. Works with any SVG content.  **Please note**: Can not be used with the `xsmall` prop due to the small size.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/docs-assets--docs Get started with PostNord assets.}
         */
        "icon"?: string;
        /**
          * The label of the tag.
         */
        "label": string;
        /**
          * Set larger tag.
          * @category Size
         */
        "large"?: boolean;
        /**
          * Set smaller tag.
          * @category Size
         */
        "small"?: boolean;
        /**
          * Set extra small tag.
          * @category Size
         */
        "xsmall"?: boolean;
    }
    /**
     * The `pn-text-link` is a styled `a` element with some extra functionality built in. Such as `icon` and `light` support.
     */
    interface PnTextLink {
        /**
          * Treat the link as a download link.
          * @category Link attributes
         */
        "download"?: string;
        /**
          * The URL string.
         */
        "href": string;
        /**
          * Set the hreflang of the URL destination.
          * @category Link attributes
         */
        "hreflang"?: string;
        /**
          * SVG content of the icon.
          * @category Visual
         */
        "icon"?: string;
        /**
          * The link text.
         */
        "label"?: string;
        /**
          * Align the icon on the left.
          * @category Visual
         */
        "leftIcon": boolean;
        /**
          * Use the light version of the link.
          * @category Visual
         */
        "light": boolean;
        /**
          * Set a unique html ID of the a element.
          * @category Link attributes
         */
        "linkid"?: string;
        /**
          * Link media.
          * @category Link attributes
         */
        "media"?: string;
        /**
          * Set referrerpolicy on the link.
          * @category Link attributes
         */
        "referrerpolicy"?: ReferrerPolicy;
        /**
          * Set the rel of the link.
          * @category Link attributes
         */
        "rel": string;
        /**
          * Set the target of the link.
          * @category Link attributes
         */
        "target"?: string;
    }
    /**
     * The `pn-textarea` is built with a native `textarea`.
     * This means you can use native events to listen to the input.
     * @nativeInput Use the `input` event to listen to content being modified by the user.
     */
    interface PnTextarea {
        /**
          * Allow the browser to autocomplete the textarea.
          * @category HTML Textarea
         */
        "autocomplete"?: string;
        /**
          * Set the col count for the textarea.
          * @category HTML Textarea
         */
        "cols"?: number;
        /**
          * Disable the textarea.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Same as `invalid`, but will display the string as an error message under the textarea.
          * @category State
         */
        "error"?: string;
        /**
          * Set the associated form.
          * @category HTML Textarea
         */
        "form"?: string;
        /**
          * Helper text that will appear underneath the textarea. Will be overwritten if you set an `error` string
         */
        "helpertext"?: string;
        /**
          * Set the textarea as `invalid`, will make the Label and focus rings red.
          * @category State
         */
        "invalid"?: boolean;
        /**
          * The label describing the textarea.
         */
        "label": string;
        /**
          * The maximum number of characters the user should be able to add, also adds a visible counter.
          * @category HTML Textarea
         */
        "maxlength"?: number;
        /**
          * HTML name.
          * @category HTML Textarea
         */
        "name"?: string;
        /**
          * Placeholder for the textarea.
          * @category HTML Textarea
         */
        "placeholder"?: string;
        /**
          * Make the textarea readonly.
          * @category State
         */
        "readonly"?: boolean;
        /**
          * Make the textarea required.
          * @category HTML Textarea
         */
        "required"?: boolean;
        /**
          * Allow the user to resize the textarea vertically. Handle width in your own layout.
          * @category HTML Textarea
         */
        "resize"?: boolean;
        /**
          * Set the row count for the textarea.
          * @category HTML Textarea
         */
        "rows"?: number;
        /**
          * Allow the browser to spellcheck the textarea.
          * @category HTML Textarea
         */
        "spellcheck": boolean;
        /**
          * A unique ID connecting the element to the label.
          * @category HTML Textarea
         */
        "textareaid"?: string;
        /**
          * Set the textarea as `valid`, will make the Label and focus rings green.
          * @category State
         */
        "valid"?: boolean;
        /**
          * The textarea content, do not provide slotted content.
         */
        "value": string;
        /**
          * Set the wrap control.
          * @category HTML Textarea
         */
        "wrap"?: string;
    }
    /**
     * The `pn-tile` is a navigational element that is intended to be accompanied by an illustration.
     * It is very important that you use the `label` and `url`. This component renders an `a` element if the URL prop is set,
     * so you do not need to wrap or nest the tile in another `a` element. Doing so makes the component inaccessible.
     */
    interface PnTile {
        /**
          * Use the horizontal tile.
          * @category Layout
         */
        "horizontal"?: boolean;
        /**
          * The SVG content of a decorative icon.
          * @category Image
         */
        "icon"?: string;
        /**
          * The SVG content of an illustration.
          * @category Image
         */
        "illustration"?: string;
        /**
          * Label of the link. This is required for the component to be accessible.
         */
        "label": string;
        /**
          * The rel attribute of the link.
          * @category href
         */
        "rel"?: string;
        /**
          * The target attribute of the link.
          * @category href
         */
        "target"?: string;
        /**
          * Set a string of text for the tile. Same as the default slot.
         */
        "text"?: string;
        /**
          * The link of the tile. This is required for the component to be accessible.
          * @category href
         */
        "url": string;
    }
    /**
     * This component is able to fill many roles of a classic toast.
     * It has 4 different colors, a temporary state, hide button, icon and illustration support.
     * The `pn-toast` will expand to its parent containers full width.
     * Either limit the parent width or set a CSS rule to your specific width if needed.
     */
    interface PnToast {
        /**
          * Default color is blue, you also have the option of success (green), warning (orange) and error (red).
          * @category Visual
         */
        "appearance"?: '' | 'success' | 'warning' | 'error';
        /**
          * Show close button.
          * @category Features
         */
        "closable": boolean;
        /**
          * Set a title for the toast. Requires the `text` prop in order to work.
          * @description Can be used together with slotted content.
         */
        "heading"?: string;
        /**
          * Control the visibility of the toast. If the `closable` prop is active, the toast will set the `hide` prop on its own.
          * @see {@link closable }
          * @category Features
         */
        "hide": boolean;
        /**
          * Set an SVG icon.
          * @category Visual
         */
        "icon"?: string;
        /**
          * Set an SVG illustration.
          * @category Visual
         */
        "illustration"?: string;
        /**
          * Manually set the language, only needed if the `closable` prop is enabled.
          * @see {@link closable }
          * @category Features
         */
        "language"?: PnLanguages;
        /**
          * This will apply a shadow and border to the toast.
          * @category Visual
         */
        "temporary": boolean;
        /**
          * Set a paragraph of text for the toast.
          * @description Can be used together with slotted content.
         */
        "text"?: string;
        /**
          * Give the toast a HTML ID.
         */
        "toastId"?: string;
    }
    /**
     * The `pn-toggle-switch` is built with a native `input[type="checkbox"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the switch state is being toggled.
     */
    interface PnToggleSwitch {
        /**
          * Precheck the toggle.
         */
        "checked": boolean;
        /**
          * Disable the toggle.
          * @category State
         */
        "disabled": boolean;
        /**
          * Provide a helpertext for the toggle switch.
         */
        "helpertext"?: string;
        /**
          * A label for the toggle switch.
         */
        "label": string;
        /**
          * Make the toggle larger.
          * @category Visual
         */
        "large": boolean;
        /**
          * Set the loading state.
          * @category State
         */
        "loading": boolean;
        /**
          * HTML toggle name.
          * @category HTML
         */
        "name"?: string;
        /**
          * Make the toggle smaller.
          * @category Visual
         */
        "small": boolean;
        /**
          * Set a unique HTML id.
         */
        "toggleid": string;
        /**
          * HTML toggle value.
          * @category HTML
         */
        "value"?: string;
    }
    /**
     * The `pn-tooltip` can display slotted HTML content or a text `string` with the `tooltip` prop.
     * Remember that the component is techincally a `button` element, don't put any HTML content that would be out of place in a regular button
     * (no headlines, other input elements, etc...).
     */
    interface PnTooltip {
        /**
          * Apply the light color if you use a dark background.
         */
        "light": boolean;
        /**
          * Overrides the slotted content to create a small tooltip instead.
         */
        "tooltip"?: string;
        /**
          * Apply the warning color and change the icon to `!`.
         */
        "warning": boolean;
    }
    /**
     * Check the delivery date for letters, newspapers and direct mail that are distributed every second day.
     */
    interface PnZipcodeSearch {
        /**
          * The `language` property will be prioritized before the pnTopbar language.
         */
        "language"?: PnZipCodeSearchLanguages;
        /**
          * Set a pre initialized value.
         */
        "value"?: string;
    }
}
export interface PnAccordionRowCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnAccordionRowElement;
}
export interface PnButtonCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnButtonElement;
}
export interface PnCardCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnCardElement;
}
export interface PnCounterCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnCounterElement;
}
export interface PnDatePickerCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnDatePickerElement;
}
export interface PnFileUploadCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnFileUploadElement;
}
export interface PnModalCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnModalElement;
}
export interface PnMultiselectCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnMultiselectElement;
}
export interface PnPageNavCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnPageNavElement;
}
export interface PnPageNavDropdownItemCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnPageNavDropdownItemElement;
}
export interface PnPageNavItemCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnPageNavItemElement;
}
export interface PnPaginationCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnPaginationElement;
}
export interface PnProgressIndicatorCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnProgressIndicatorElement;
}
export interface PnProgressIndicatorStepCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnProgressIndicatorStepElement;
}
export interface PnSearchFieldCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnSearchFieldElement;
}
export interface PnSegmentCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnSegmentElement;
}
export interface PnTabCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnTabElement;
}
export interface PnTablistCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnTablistElement;
}
export interface PnTileCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnTileElement;
}
export interface PnToastCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnToastElement;
}
export interface PnZipcodeSearchCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLPnZipcodeSearchElement;
}
declare global {
    /**
     * The `pn-accordion` is a wrapper for `pn-accordion-row` components.
     * This component gives the accordion rows some space between each one and provides the `single` feature.
     * Which will force the rule that only a single row to be open at one time.
     */
    interface HTMLPnAccordionElement extends Components.PnAccordion, HTMLStencilElement {
    }
    var HTMLPnAccordionElement: {
        prototype: HTMLPnAccordionElement;
        new (): HTMLPnAccordionElement;
    };
    interface HTMLPnAccordionRowElementEventMap {
        "togglerow": { element: HTMLElement; state: Boolean };
    }
    /**
     * Use this row component inside a `pn-accordion` to create an accordion group.
     * **Note**: you can use the `pn-accordion-row` without the parent accordion.
     * But you will have to style the gap between each row.
     */
    interface HTMLPnAccordionRowElement extends Components.PnAccordionRow, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnAccordionRowElementEventMap>(type: K, listener: (this: HTMLPnAccordionRowElement, ev: PnAccordionRowCustomEvent<HTMLPnAccordionRowElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnAccordionRowElementEventMap>(type: K, listener: (this: HTMLPnAccordionRowElement, ev: PnAccordionRowCustomEvent<HTMLPnAccordionRowElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnAccordionRowElement: {
        prototype: HTMLPnAccordionRowElement;
        new (): HTMLPnAccordionRowElement;
    };
    interface HTMLPnButtonElementEventMap {
        "pnClick": MouseEvent;
    }
    /**
     * The `pn-button` is built with a native `button` or `a` element, if you use the `href` attribute.
     * @nativeClick Use the `click` event to listen when the button is clicked.
     */
    interface HTMLPnButtonElement extends Components.PnButton, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnButtonElementEventMap>(type: K, listener: (this: HTMLPnButtonElement, ev: PnButtonCustomEvent<HTMLPnButtonElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnButtonElementEventMap>(type: K, listener: (this: HTMLPnButtonElement, ev: PnButtonCustomEvent<HTMLPnButtonElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnButtonElement: {
        prototype: HTMLPnButtonElement;
        new (): HTMLPnButtonElement;
    };
    /**
     * The open/closing of the dropdown is handled by the component itself.
     * @nativeClick Use the `click` event to listen when the button is clicked.
     */
    interface HTMLPnButtonDropdownElement extends Components.PnButtonDropdown, HTMLStencilElement {
    }
    var HTMLPnButtonDropdownElement: {
        prototype: HTMLPnButtonDropdownElement;
        new (): HTMLPnButtonDropdownElement;
    };
    interface HTMLPnCardElementEventMap {
        "pnCard": { click: MouseEvent };
    }
    /**
     * The card component is more than just a navigational element.
     * It is a flexible component that can be used as a product item, a clickable link card, etc...
     * Setting the `href` prop will transform the entire `pn-card` into a clickable element.
     * If you need content to be interactable inside the card, do not use the `href` prop.
     */
    interface HTMLPnCardElement extends Components.PnCard, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnCardElementEventMap>(type: K, listener: (this: HTMLPnCardElement, ev: PnCardCustomEvent<HTMLPnCardElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnCardElementEventMap>(type: K, listener: (this: HTMLPnCardElement, ev: PnCardCustomEvent<HTMLPnCardElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnCardElement: {
        prototype: HTMLPnCardElement;
        new (): HTMLPnCardElement;
    };
    /**
     * The `pn-checkbox` is built with a native `input[type="checkbox"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the checkbox state is being toggled.
     */
    interface HTMLPnCheckboxElement extends Components.PnCheckbox, HTMLStencilElement {
    }
    var HTMLPnCheckboxElement: {
        prototype: HTMLPnCheckboxElement;
        new (): HTMLPnCheckboxElement;
    };
    /**
     * The `pn-choice-chip` is built with a native `input[type="checkbox|radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the choice chip state is being toggled. Works for both checkbox/radio variant.
     */
    interface HTMLPnChoiceChipElement extends Components.PnChoiceChip, HTMLStencilElement {
    }
    var HTMLPnChoiceChipElement: {
        prototype: HTMLPnChoiceChipElement;
        new (): HTMLPnChoiceChipElement;
    };
    interface HTMLPnCounterElementEventMap {
        "counterInput": { value: number; input?: boolean; decrease?: boolean; increase?: boolean };
    }
    /**
     * The `pn-counter` is an input with a button on each side that can be used to increase and decrease the input value.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface HTMLPnCounterElement extends Components.PnCounter, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnCounterElementEventMap>(type: K, listener: (this: HTMLPnCounterElement, ev: PnCounterCustomEvent<HTMLPnCounterElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnCounterElementEventMap>(type: K, listener: (this: HTMLPnCounterElement, ev: PnCounterCustomEvent<HTMLPnCounterElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnCounterElement: {
        prototype: HTMLPnCounterElement;
        new (): HTMLPnCounterElement;
    };
    interface HTMLPnDatePickerElementEventMap {
        "dateselection": PnDatePickerSelectEvent;
        "dateSelection": PnDatePickerSelectEvent;
        "dateInvalid": { start?: string; end?: string };
        "toggleCalendar": boolean;
        "currentView": CalendarView;
    }
    /**
     * The date picker allows a single or a range of dates to be selected.
     * Based on the `format` prop, separators will automatically be added if you type the date.
     * You can navigate the calendar grid with your keyboard.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface HTMLPnDatePickerElement extends Components.PnDatePicker, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnDatePickerElementEventMap>(type: K, listener: (this: HTMLPnDatePickerElement, ev: PnDatePickerCustomEvent<HTMLPnDatePickerElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnDatePickerElementEventMap>(type: K, listener: (this: HTMLPnDatePickerElement, ev: PnDatePickerCustomEvent<HTMLPnDatePickerElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnDatePickerElement: {
        prototype: HTMLPnDatePickerElement;
        new (): HTMLPnDatePickerElement;
    };
    /**
     * The fielset is a wrapper to give context and information about inputs. Most commonly, a set of radio/checkboxes.
     * However, you may include any type of input such as textareas, toggles and selects.
     */
    interface HTMLPnFieldsetElement extends Components.PnFieldset, HTMLStencilElement {
    }
    var HTMLPnFieldsetElement: {
        prototype: HTMLPnFieldsetElement;
        new (): HTMLPnFieldsetElement;
    };
    interface HTMLPnFileUploadElementEventMap {
        "filesAdded": PnUploadFileItem[];
        "update": { files: PnUploadFileItem[]; element: HTMLPnFileUploadElement };
        "fileuploaderror": Error;
        "valid": this;
        "uploadFile": {
    file: PnUploadFileItem;
    index: number;
    uploader: any;
  };
        "uploadCancelled": PnUploadFileItem;
        "uploadCompleted": PnUploadFileItem[];
    }
    /**
     * Users can drop files directly into the upload area of the component
     * or simply click on it to open their native file explorer.
     * @nativeChange Use the `change` event to listen when the input receives files.
     * @nativeCancel The `cancel` event lets you know the user canceled their selection.
     * Either via clicking on the "Cancel" button or pressing `ESC`.
     */
    interface HTMLPnFileUploadElement extends Components.PnFileUpload, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnFileUploadElementEventMap>(type: K, listener: (this: HTMLPnFileUploadElement, ev: PnFileUploadCustomEvent<HTMLPnFileUploadElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnFileUploadElementEventMap>(type: K, listener: (this: HTMLPnFileUploadElement, ev: PnFileUploadCustomEvent<HTMLPnFileUploadElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnFileUploadElement: {
        prototype: HTMLPnFileUploadElement;
        new (): HTMLPnFileUploadElement;
    };
    /**
     * The default market and language is SE/en.
     * Make sure you set the market **and** language prop.
     * Example: Setting the `language` prop `da` will not display anything, as `da` does not exist on the `SE` market.
     * @deprecated This component has been replaced with the {@link https://portal.postnord.com/web-components/?path=/docs/external-components-pn-footer-nav--docs pn-footer-nav}.
     */
    interface HTMLPnFooterElement extends Components.PnFooter, HTMLStencilElement {
    }
    var HTMLPnFooterElement: {
        prototype: HTMLPnFooterElement;
        new (): HTMLPnFooterElement;
    };
    interface HTMLPnHeaderElement extends Components.PnHeader, HTMLStencilElement {
    }
    var HTMLPnHeaderElement: {
        prototype: HTMLPnHeaderElement;
        new (): HTMLPnHeaderElement;
    };
    /**
     * The `pn-icon` is a wrapper for an SVG string.
     * While its built with PostNords specific icon dimensions in mind (24x24px), you can use any SVG content in this component.
     * As long as its 3x3 in size, there should be no problem.
     * The color feature will not overwrite the color of flags.
     */
    interface HTMLPnIconElement extends Components.PnIcon, HTMLStencilElement {
    }
    var HTMLPnIconElement: {
        prototype: HTMLPnIconElement;
        new (): HTMLPnIconElement;
    };
    interface HTMLPnIllustrationElement extends Components.PnIllustration, HTMLStencilElement {
    }
    var HTMLPnIllustrationElement: {
        prototype: HTMLPnIllustrationElement;
        new (): HTMLPnIllustrationElement;
    };
    /**
     * The `pn-input` is a regular `input` but styled. This means you can use native events to listen to the changes.
     * Always use the `label` prop to make sure the input is accessible.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface HTMLPnInputElement extends Components.PnInput, HTMLStencilElement {
    }
    var HTMLPnInputElement: {
        prototype: HTMLPnInputElement;
        new (): HTMLPnInputElement;
    };
    interface HTMLPnModalElementEventMap {
        "close": boolean;
    }
    /**
     * Present content in a modal that overlays everything on the current page.
     * Use the prop `open` to toggle the visiblity.
     * Use the event `close` to determine when the modal is being closed by the user.
     */
    interface HTMLPnModalElement extends Components.PnModal, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnModalElementEventMap>(type: K, listener: (this: HTMLPnModalElement, ev: PnModalCustomEvent<HTMLPnModalElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnModalElementEventMap>(type: K, listener: (this: HTMLPnModalElement, ev: PnModalCustomEvent<HTMLPnModalElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnModalElement: {
        prototype: HTMLPnModalElement;
        new (): HTMLPnModalElement;
    };
    interface HTMLPnMultiselectElementEventMap {
        "toggleSelect": { open: boolean };
        "allOptions": PnMultiselectOption[];
        "selectedOption": PnMultiselectOption;
        "selectedAllOptions": {
    checked: boolean;
    searching: boolean;
    query?: string;
    found?: PnMultiselectOption[];
  };
        "searchInput": {
    query: string;
    found?: PnMultiselectOption[];
  };
    }
    /**
     * The `pn-multiselect` gets its options via javascript.
     * Native HTML does not accept arrays of objects. Most frameworks solves this automatically (Vue, react, etc...),
     * but keep this in mind if you use this component outside of a framework environment.
     * @nativeChange The `pn-multiselect` is built with `input[type=checkbox]` elements, so the `change` event works. However, we recommend the customEvents described above.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-input-multiselect--docs#pn-multiselect%20(options) Options documentation}
     */
    interface HTMLPnMultiselectElement extends Components.PnMultiselect, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnMultiselectElementEventMap>(type: K, listener: (this: HTMLPnMultiselectElement, ev: PnMultiselectCustomEvent<HTMLPnMultiselectElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnMultiselectElementEventMap>(type: K, listener: (this: HTMLPnMultiselectElement, ev: PnMultiselectCustomEvent<HTMLPnMultiselectElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnMultiselectElement: {
        prototype: HTMLPnMultiselectElement;
        new (): HTMLPnMultiselectElement;
    };
    interface HTMLPnOcrSearchElement extends Components.PnOcrSearch, HTMLStencilElement {
    }
    var HTMLPnOcrSearchElement: {
        prototype: HTMLPnOcrSearchElement;
        new (): HTMLPnOcrSearchElement;
    };
    interface HTMLPnPageNavElementEventMap {
        "navchange": string;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface HTMLPnPageNavElement extends Components.PnPageNav, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnPageNavElementEventMap>(type: K, listener: (this: HTMLPnPageNavElement, ev: PnPageNavCustomEvent<HTMLPnPageNavElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnPageNavElementEventMap>(type: K, listener: (this: HTMLPnPageNavElement, ev: PnPageNavCustomEvent<HTMLPnPageNavElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnPageNavElement: {
        prototype: HTMLPnPageNavElement;
        new (): HTMLPnPageNavElement;
    };
    interface HTMLPnPageNavDropdownItemElementEventMap {
        "itemselection": string;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface HTMLPnPageNavDropdownItemElement extends Components.PnPageNavDropdownItem, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnPageNavDropdownItemElementEventMap>(type: K, listener: (this: HTMLPnPageNavDropdownItemElement, ev: PnPageNavDropdownItemCustomEvent<HTMLPnPageNavDropdownItemElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnPageNavDropdownItemElementEventMap>(type: K, listener: (this: HTMLPnPageNavDropdownItemElement, ev: PnPageNavDropdownItemCustomEvent<HTMLPnPageNavDropdownItemElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnPageNavDropdownItemElement: {
        prototype: HTMLPnPageNavDropdownItemElement;
        new (): HTMLPnPageNavDropdownItemElement;
    };
    interface HTMLPnPageNavItemElementEventMap {
        "itemselection": string;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface HTMLPnPageNavItemElement extends Components.PnPageNavItem, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnPageNavItemElementEventMap>(type: K, listener: (this: HTMLPnPageNavItemElement, ev: PnPageNavItemCustomEvent<HTMLPnPageNavItemElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnPageNavItemElementEventMap>(type: K, listener: (this: HTMLPnPageNavItemElement, ev: PnPageNavItemCustomEvent<HTMLPnPageNavItemElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnPageNavItemElement: {
        prototype: HTMLPnPageNavItemElement;
        new (): HTMLPnPageNavItemElement;
    };
    interface HTMLPnPaginationElementEventMap {
        "pageSelected": { page: number; mouse: MouseEvent };
        "rowsSelected": { rows: number; change: Event };
    }
    /**
     * Accessible pagination needs each item to link to a different part of the document.
     * This means that you must `preventDefault` on the `MouseEvent` emitted from the `pageSelected` event if you have a SPA.
     * If you set a `page` value that is higher than `pages`, the component will automatically lower it to the `pages` value.
     */
    interface HTMLPnPaginationElement extends Components.PnPagination, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnPaginationElementEventMap>(type: K, listener: (this: HTMLPnPaginationElement, ev: PnPaginationCustomEvent<HTMLPnPaginationElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnPaginationElementEventMap>(type: K, listener: (this: HTMLPnPaginationElement, ev: PnPaginationCustomEvent<HTMLPnPaginationElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnPaginationElement: {
        prototype: HTMLPnPaginationElement;
        new (): HTMLPnPaginationElement;
    };
    interface HTMLPnProgressBarElement extends Components.PnProgressBar, HTMLStencilElement {
    }
    var HTMLPnProgressBarElement: {
        prototype: HTMLPnProgressBarElement;
        new (): HTMLPnProgressBarElement;
    };
    interface HTMLPnProgressIndicatorElementEventMap {
        "progresschange": number;
    }
    interface HTMLPnProgressIndicatorElement extends Components.PnProgressIndicator, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnProgressIndicatorElementEventMap>(type: K, listener: (this: HTMLPnProgressIndicatorElement, ev: PnProgressIndicatorCustomEvent<HTMLPnProgressIndicatorElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnProgressIndicatorElementEventMap>(type: K, listener: (this: HTMLPnProgressIndicatorElement, ev: PnProgressIndicatorCustomEvent<HTMLPnProgressIndicatorElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnProgressIndicatorElement: {
        prototype: HTMLPnProgressIndicatorElement;
        new (): HTMLPnProgressIndicatorElement;
    };
    interface HTMLPnProgressIndicatorStepElementEventMap {
        "setactivestep": number;
    }
    interface HTMLPnProgressIndicatorStepElement extends Components.PnProgressIndicatorStep, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnProgressIndicatorStepElementEventMap>(type: K, listener: (this: HTMLPnProgressIndicatorStepElement, ev: PnProgressIndicatorStepCustomEvent<HTMLPnProgressIndicatorStepElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnProgressIndicatorStepElementEventMap>(type: K, listener: (this: HTMLPnProgressIndicatorStepElement, ev: PnProgressIndicatorStepCustomEvent<HTMLPnProgressIndicatorStepElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnProgressIndicatorStepElement: {
        prototype: HTMLPnProgressIndicatorStepElement;
        new (): HTMLPnProgressIndicatorStepElement;
    };
    /**
     * The `pn-progress-stepper` is used to visualize the users progress through a flow (checkout/survey, etc...).
     */
    interface HTMLPnProgressStepperElement extends Components.PnProgressStepper, HTMLStencilElement {
    }
    var HTMLPnProgressStepperElement: {
        prototype: HTMLPnProgressStepperElement;
        new (): HTMLPnProgressStepperElement;
    };
    /**
     * The `pn-radio-button` is built with a native `input[type="radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the radio state is being changed.
     */
    interface HTMLPnRadioButtonElement extends Components.PnRadioButton, HTMLStencilElement {
    }
    var HTMLPnRadioButtonElement: {
        prototype: HTMLPnRadioButtonElement;
        new (): HTMLPnRadioButtonElement;
    };
    /**
     * There are no events or features other than the `icon`, `small` and `language` prop.
     * Our rule is to not have disabled buttons.
     * However, this component is an exception for a very specific use case regarding portal users.
     */
    interface HTMLPnReadOnlyButtonElement extends Components.PnReadOnlyButton, HTMLStencilElement {
    }
    var HTMLPnReadOnlyButtonElement: {
        prototype: HTMLPnReadOnlyButtonElement;
        new (): HTMLPnReadOnlyButtonElement;
    };
    interface HTMLPnSearchFieldElementEventMap {
        "search": string;
        "update": string;
    }
    interface HTMLPnSearchFieldElement extends Components.PnSearchField, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnSearchFieldElementEventMap>(type: K, listener: (this: HTMLPnSearchFieldElement, ev: PnSearchFieldCustomEvent<HTMLPnSearchFieldElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnSearchFieldElementEventMap>(type: K, listener: (this: HTMLPnSearchFieldElement, ev: PnSearchFieldCustomEvent<HTMLPnSearchFieldElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnSearchFieldElement: {
        prototype: HTMLPnSearchFieldElement;
        new (): HTMLPnSearchFieldElement;
    };
    interface HTMLPnSegmentElementEventMap {
        "segmentHover": MouseEvent;
    }
    /**
     * The `pn-segment` is built with a native `input[type="radio"]` in the background.
     * Do not listen to events on the `pn-segment`, but on the `pn-segmented-control` instead.
     */
    interface HTMLPnSegmentElement extends Components.PnSegment, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnSegmentElementEventMap>(type: K, listener: (this: HTMLPnSegmentElement, ev: PnSegmentCustomEvent<HTMLPnSegmentElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnSegmentElementEventMap>(type: K, listener: (this: HTMLPnSegmentElement, ev: PnSegmentCustomEvent<HTMLPnSegmentElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnSegmentElement: {
        prototype: HTMLPnSegmentElement;
        new (): HTMLPnSegmentElement;
    };
    /**
     * The `pn-segmented-control` and `pn-segmented` is built with native `input[type="radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the segment state is being changed.
     */
    interface HTMLPnSegmentedControlElement extends Components.PnSegmentedControl, HTMLStencilElement {
    }
    var HTMLPnSegmentedControlElement: {
        prototype: HTMLPnSegmentedControlElement;
        new (): HTMLPnSegmentedControlElement;
    };
    /**
     * The `pn-select` uses a native `select` element under the hood.
     * Use the slot to include `option` elements.
     * Just like a regular `select`, you can use the `selected` prop on the nested option elements to preselect an option.
     * @nativeChange Use the `change` event to listen to changes on the select element.
     */
    interface HTMLPnSelectElement extends Components.PnSelect, HTMLStencilElement {
    }
    var HTMLPnSelectElement: {
        prototype: HTMLPnSelectElement;
        new (): HTMLPnSelectElement;
    };
    interface HTMLPnSpinnerElement extends Components.PnSpinner, HTMLStencilElement {
    }
    var HTMLPnSpinnerElement: {
        prototype: HTMLPnSpinnerElement;
        new (): HTMLPnSpinnerElement;
    };
    interface HTMLPnTabElementEventMap {
        "setActiveTab": { val: string; el: HTMLPnTabElement };
        "tabEnter": MouseEvent | FocusEvent;
        "tabLeave": MouseEvent | FocusEvent;
    }
    interface HTMLPnTabElement extends Components.PnTab, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnTabElementEventMap>(type: K, listener: (this: HTMLPnTabElement, ev: PnTabCustomEvent<HTMLPnTabElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnTabElementEventMap>(type: K, listener: (this: HTMLPnTabElement, ev: PnTabCustomEvent<HTMLPnTabElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnTabElement: {
        prototype: HTMLPnTabElement;
        new (): HTMLPnTabElement;
    };
    /**
     * The `pn-table` component is just a wrapper for your HTML table element.
     * You need to create the markup, but the component will deal with the styling.
     * We have a built in class for divs inside table colums called `column-wrapper`.
     * This will line up your content and provide a grid gap.
     */
    interface HTMLPnTableElement extends Components.PnTable, HTMLStencilElement {
    }
    var HTMLPnTableElement: {
        prototype: HTMLPnTableElement;
        new (): HTMLPnTableElement;
    };
    interface HTMLPnTablistElementEventMap {
        "tabchange": string;
    }
    interface HTMLPnTablistElement extends Components.PnTablist, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnTablistElementEventMap>(type: K, listener: (this: HTMLPnTablistElement, ev: PnTablistCustomEvent<HTMLPnTablistElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnTablistElementEventMap>(type: K, listener: (this: HTMLPnTablistElement, ev: PnTablistCustomEvent<HTMLPnTablistElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnTablistElement: {
        prototype: HTMLPnTablistElement;
        new (): HTMLPnTablistElement;
    };
    /**
     * The `pn-tag` is a non-interactive visual marker designed to emphasize important aspects of an item, such as its status.
     */
    interface HTMLPnTagElement extends Components.PnTag, HTMLStencilElement {
    }
    var HTMLPnTagElement: {
        prototype: HTMLPnTagElement;
        new (): HTMLPnTagElement;
    };
    /**
     * The `pn-text-link` is a styled `a` element with some extra functionality built in. Such as `icon` and `light` support.
     */
    interface HTMLPnTextLinkElement extends Components.PnTextLink, HTMLStencilElement {
    }
    var HTMLPnTextLinkElement: {
        prototype: HTMLPnTextLinkElement;
        new (): HTMLPnTextLinkElement;
    };
    /**
     * The `pn-textarea` is built with a native `textarea`.
     * This means you can use native events to listen to the input.
     * @nativeInput Use the `input` event to listen to content being modified by the user.
     */
    interface HTMLPnTextareaElement extends Components.PnTextarea, HTMLStencilElement {
    }
    var HTMLPnTextareaElement: {
        prototype: HTMLPnTextareaElement;
        new (): HTMLPnTextareaElement;
    };
    interface HTMLPnTileElementEventMap {
        "pnTile": { click: MouseEvent };
    }
    /**
     * The `pn-tile` is a navigational element that is intended to be accompanied by an illustration.
     * It is very important that you use the `label` and `url`. This component renders an `a` element if the URL prop is set,
     * so you do not need to wrap or nest the tile in another `a` element. Doing so makes the component inaccessible.
     */
    interface HTMLPnTileElement extends Components.PnTile, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnTileElementEventMap>(type: K, listener: (this: HTMLPnTileElement, ev: PnTileCustomEvent<HTMLPnTileElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnTileElementEventMap>(type: K, listener: (this: HTMLPnTileElement, ev: PnTileCustomEvent<HTMLPnTileElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnTileElement: {
        prototype: HTMLPnTileElement;
        new (): HTMLPnTileElement;
    };
    interface HTMLPnToastElementEventMap {
        "close": boolean;
        "hidden": boolean;
    }
    /**
     * This component is able to fill many roles of a classic toast.
     * It has 4 different colors, a temporary state, hide button, icon and illustration support.
     * The `pn-toast` will expand to its parent containers full width.
     * Either limit the parent width or set a CSS rule to your specific width if needed.
     */
    interface HTMLPnToastElement extends Components.PnToast, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnToastElementEventMap>(type: K, listener: (this: HTMLPnToastElement, ev: PnToastCustomEvent<HTMLPnToastElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnToastElementEventMap>(type: K, listener: (this: HTMLPnToastElement, ev: PnToastCustomEvent<HTMLPnToastElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnToastElement: {
        prototype: HTMLPnToastElement;
        new (): HTMLPnToastElement;
    };
    /**
     * The `pn-toggle-switch` is built with a native `input[type="checkbox"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the switch state is being toggled.
     */
    interface HTMLPnToggleSwitchElement extends Components.PnToggleSwitch, HTMLStencilElement {
    }
    var HTMLPnToggleSwitchElement: {
        prototype: HTMLPnToggleSwitchElement;
        new (): HTMLPnToggleSwitchElement;
    };
    /**
     * The `pn-tooltip` can display slotted HTML content or a text `string` with the `tooltip` prop.
     * Remember that the component is techincally a `button` element, don't put any HTML content that would be out of place in a regular button
     * (no headlines, other input elements, etc...).
     */
    interface HTMLPnTooltipElement extends Components.PnTooltip, HTMLStencilElement {
    }
    var HTMLPnTooltipElement: {
        prototype: HTMLPnTooltipElement;
        new (): HTMLPnTooltipElement;
    };
    interface HTMLPnZipcodeSearchElementEventMap {
        "searchsuccessful": boolean;
    }
    /**
     * Check the delivery date for letters, newspapers and direct mail that are distributed every second day.
     */
    interface HTMLPnZipcodeSearchElement extends Components.PnZipcodeSearch, HTMLStencilElement {
        addEventListener<K extends keyof HTMLPnZipcodeSearchElementEventMap>(type: K, listener: (this: HTMLPnZipcodeSearchElement, ev: PnZipcodeSearchCustomEvent<HTMLPnZipcodeSearchElementEventMap[K]>) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
        addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
        removeEventListener<K extends keyof HTMLPnZipcodeSearchElementEventMap>(type: K, listener: (this: HTMLPnZipcodeSearchElement, ev: PnZipcodeSearchCustomEvent<HTMLPnZipcodeSearchElementEventMap[K]>) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
        removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
    }
    var HTMLPnZipcodeSearchElement: {
        prototype: HTMLPnZipcodeSearchElement;
        new (): HTMLPnZipcodeSearchElement;
    };
    interface HTMLElementTagNameMap {
        "pn-accordion": HTMLPnAccordionElement;
        "pn-accordion-row": HTMLPnAccordionRowElement;
        "pn-button": HTMLPnButtonElement;
        "pn-button-dropdown": HTMLPnButtonDropdownElement;
        "pn-card": HTMLPnCardElement;
        "pn-checkbox": HTMLPnCheckboxElement;
        "pn-choice-chip": HTMLPnChoiceChipElement;
        "pn-counter": HTMLPnCounterElement;
        "pn-date-picker": HTMLPnDatePickerElement;
        "pn-fieldset": HTMLPnFieldsetElement;
        "pn-file-upload": HTMLPnFileUploadElement;
        "pn-footer": HTMLPnFooterElement;
        "pn-header": HTMLPnHeaderElement;
        "pn-icon": HTMLPnIconElement;
        "pn-illustration": HTMLPnIllustrationElement;
        "pn-input": HTMLPnInputElement;
        "pn-modal": HTMLPnModalElement;
        "pn-multiselect": HTMLPnMultiselectElement;
        "pn-ocr-search": HTMLPnOcrSearchElement;
        "pn-page-nav": HTMLPnPageNavElement;
        "pn-page-nav-dropdown-item": HTMLPnPageNavDropdownItemElement;
        "pn-page-nav-item": HTMLPnPageNavItemElement;
        "pn-pagination": HTMLPnPaginationElement;
        "pn-progress-bar": HTMLPnProgressBarElement;
        "pn-progress-indicator": HTMLPnProgressIndicatorElement;
        "pn-progress-indicator-step": HTMLPnProgressIndicatorStepElement;
        "pn-progress-stepper": HTMLPnProgressStepperElement;
        "pn-radio-button": HTMLPnRadioButtonElement;
        "pn-read-only-button": HTMLPnReadOnlyButtonElement;
        "pn-search-field": HTMLPnSearchFieldElement;
        "pn-segment": HTMLPnSegmentElement;
        "pn-segmented-control": HTMLPnSegmentedControlElement;
        "pn-select": HTMLPnSelectElement;
        "pn-spinner": HTMLPnSpinnerElement;
        "pn-tab": HTMLPnTabElement;
        "pn-table": HTMLPnTableElement;
        "pn-tablist": HTMLPnTablistElement;
        "pn-tag": HTMLPnTagElement;
        "pn-text-link": HTMLPnTextLinkElement;
        "pn-textarea": HTMLPnTextareaElement;
        "pn-tile": HTMLPnTileElement;
        "pn-toast": HTMLPnToastElement;
        "pn-toggle-switch": HTMLPnToggleSwitchElement;
        "pn-tooltip": HTMLPnTooltipElement;
        "pn-zipcode-search": HTMLPnZipcodeSearchElement;
    }
}
declare namespace LocalJSX {
    /**
     * The `pn-accordion` is a wrapper for `pn-accordion-row` components.
     * This component gives the accordion rows some space between each one and provides the `single` feature.
     * Which will force the rule that only a single row to be open at one time.
     */
    interface PnAccordion {
        /**
          * Only allow a single row to be open at once.
         */
        "single"?: boolean;
        /**
          * Optional prop that removes the default white background on the accordion row
         */
        "transparent"?: boolean;
    }
    /**
     * Use this row component inside a `pn-accordion` to create an accordion group.
     * **Note**: you can use the `pn-accordion-row` without the parent accordion.
     * But you will have to style the gap between each row.
     */
    interface PnAccordionRow {
        /**
          * Optional unique id for the `summary` element.
          * @category ID
         */
        "buttonid"?: string;
        /**
          * Optional unique id for the `div` element containing the content.
          * @category ID
         */
        "contentid"?: string;
        /**
          * The label/title of the accordion row, you can also pass a slot with the name "label" if you want to put custom HTML content in there.
         */
        "label"?: string;
        /**
          * Dispatched every time the row is toggled. Includes the row element and the boolean `state` prop.
         */
        "onTogglerow"?: (event: PnAccordionRowCustomEvent<{ element: HTMLElement; state: Boolean }>) => void;
        /**
          * The open/close status of the accordion row.
         */
        "state"?: boolean;
        /**
          * Optional prop that removes the default white background on the accordion row
         */
        "transparent"?: boolean;
    }
    /**
     * The `pn-button` is built with a native `button` or `a` element, if you use the `href` attribute.
     * @nativeClick Use the `click` event to listen when the button is clicked.
     */
    interface PnButton {
        /**
          * Select the button appearance: default (blue), `light` (white) and  `warning` (red).
          * @category Visual
         */
        "appearance"?: PnButtonAppearance;
        /**
          * HTML aria-controls attribute.
          * @category HTML attributes
         */
        "ariacontrols"?: string;
        /**
          * HTML aria-current attribute.
          * @category HTML attributes
         */
        "ariacurrent"?: string;
        /**
          * HTML aria-expanded attribute.
          * @category HTML attributes
         */
        "ariaexpanded"?: string;
        /**
          * HTML aria-haspopup attribute.
          * @category HTML attributes
         */
        "ariahaspopup"?: string;
        /**
          * HTML aria-label attribute.
          * @category HTML attributes
         */
        "arialabel"?: string;
        /**
          * HTML aria-labelledby attribute.
          * @category HTML attributes
         */
        "arialabelledby"?: string;
        /**
          * HTML aria-pressed attribute.
          * @category HTML attributes
         */
        "ariapressed"?: string;
        /**
          * HTML ID.
          * @category HTML attributes
         */
        "buttonId"?: string;
        /**
          * The download attribute of the link.
          * @category Link
         */
        "download"?: string;
        /**
          * Connect this button to a HTML form.
          * @category Button
          * @see {@link https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#form HTML button form}
         */
        "form"?: string;
        /**
          * Pass an href to make the button into link (a-tag).
          * @category Link
         */
        "href"?: string;
        /**
          * The SVG content of the icon you want.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/docs-assets--docs pn-design-assets}
          * @category Icon
         */
        "icon"?: string;
        /**
          * Turn the button into an icon only. Requires `icon` and one of the following props to work: `tooltip`, `arialabel` or `arialabelledby`.
          * @summary __You need an `icon` selected, as well as either `tooltip`, `arialabel` or `arialabelledby` for this to work__.
          * @see {@link icon }
          * @category Icon
         */
        "iconOnly"?: boolean;
        /**
          * The label of the button, this is the same as using the default slot.
         */
        "label"?: string;
        /**
          * Place the `icon` to the left of the button.
          * @summary __You need an `icon` selected for this to work__.
          * @see {@link icon }
          * @category Icon
         */
        "leftIcon"?: boolean;
        /**
          * Display the loading indicator.
          * @category Visual
         */
        "loading"?: boolean;
        /**
          * HTML tabindex.
          * @category HTML attributes
         */
        "noTab"?: boolean;
        /**
          * This event is fired when the `button`/`a` element of the `pn-button` is clicked. Setting an eventListener for `click` on the `pn-button` will trigger if you click outside of the button area or if the button is `disabled` with the `loading` prop.
         */
        "onPnClick"?: (event: PnButtonCustomEvent<MouseEvent>) => void;
        /**
          * The rel attribute of the link.
          * @category Link
         */
        "rel"?: string;
        /**
          * Use the small button.
          * @category Visual
         */
        "small"?: boolean;
        /**
          * The target attribute of the link.
          * @category Link
         */
        "target"?: string;
        /**
          * When the user focus/hover the button, the `tooltip` text will show up.
          * @category Tooltip
         */
        "tooltip"?: string;
        /**
          * Prefer the tooltip to open upwards. Will still go downwards if there is no space.
          * @category Tooltip
         */
        "tooltipUp"?: boolean;
        /**
          * Select HTML button type.
          * @category Button
         */
        "type"?: 'button' | 'reset' | 'submit' | '';
        /**
          * Select the button variant: default (colored background), `outlined` (bordered, no background) and `borderless` (borderless, no background).
          * @category Visual
         */
        "variant"?: PnButtonVariant;
    }
    /**
     * The open/closing of the dropdown is handled by the component itself.
     * @nativeClick Use the `click` event to listen when the button is clicked.
     */
    interface PnButtonDropdown {
        /**
          * Select between `light` and `warning`.
         */
        "appearance"?: PnButtonAppearance;
        /**
          * The optional SVG content of the icon you want.
         */
        "icon"?: string;
        /**
          * The required label on the button.
         */
        "label": string;
        /**
          * Open/close the dropdown without user interaction.
         */
        "open"?: boolean;
        /**
          * Smaller button.
         */
        "small"?: boolean;
        /**
          * Tooltip (required for Icon Only).
         */
        "tooltip"?: string;
        /**
          * Select between `outlined` and `borderless`.
         */
        "variant"?: PnButtonVariant;
    }
    /**
     * The card component is more than just a navigational element.
     * It is a flexible component that can be used as a product item, a clickable link card, etc...
     * Setting the `href` prop will transform the entire `pn-card` into a clickable element.
     * If you need content to be interactable inside the card, do not use the `href` prop.
     */
    interface PnCard {
        /**
          * Select image aspect ratio. Example: '3/3', '16/9'.
          * @see {@link https://developer.mozilla.org/en-US/docs/Web/CSS/aspect-ratio CSS documentation.}
          * @category Features
         */
        "aspectRatio"?: string | '3/3' | '16/9';
        /**
          * Set a HTML id for the card. Optional and not required.
         */
        "cardId"?: string;
        /**
          * Uee the horizontal card layout.
          * @category Features
         */
        "horizontal"?: boolean;
        /**
          * The card link.
          * @category Href
         */
        "href"?: string;
        /**
          * The link text.
          * @category Href
         */
        "hrefLabel"?: string;
        /**
          * The link icon. Defaults to `arrow_right` or `open_in_new` if `target="_blank"`.
          * @category Href
         */
        "icon"?: string;
        /**
          * Headline of the card. Will act as label for the link if there is no `href-label` set.
         */
        "label"?: string;
        /**
          * The label HTML tag. Default is `h3`.
         */
        "labelTag"?: 'h2' | 'h3' | 'h4' | 'h5' | 'h6' | 'p';
        /**
          * Emitted when you click on the card link (if you use the `href` prop).
         */
        "onPnCard"?: (event: PnCardCustomEvent<{ click: MouseEvent }>) => void;
        /**
          * Set a smaller text above the `label` text.
         */
        "overline"?: string;
        /**
          * The rel attribute of the link.
          * @category Href
         */
        "rel"?: string;
        /**
          * Reverse the order of which the image will wrap.
          * @category Features
         */
        "reverse"?: boolean;
        /**
          * The target attribute of the link.
          * @category Href
         */
        "target"?: string;
        /**
          * Text content of the card.
         */
        "text"?: string;
    }
    /**
     * The `pn-checkbox` is built with a native `input[type="checkbox"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the checkbox state is being toggled.
     */
    interface PnCheckbox {
        /**
          * A unique HTML ID for the checkbox.
         */
        "checkboxid"?: string;
        /**
          * Check the radio button.
         */
        "checked"?: boolean;
        /**
          * Disable the radio button.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * This adds an optional helpertext element under the label
         */
        "helpertext"?: string;
        /**
          * Add an icon on the right of your checkbox tile. The `tile` prop must be `true` for the icon to work.
          * @category Tile
         */
        "icon"?: string;
        /**
          * Sets the checkbox to an indeterminate state, allowing for a mixed or intermediate checkbox state.
          * @category State
         */
        "indeterminate"?: boolean;
        /**
          * If set to true, color scheme will turn red, indicating that there is an issue or incorrect input related the checkbox.
          * @category State
         */
        "invalid"?: boolean;
        /**
          * The checkbox label
         */
        "label"?: string;
        /**
          * The name of the checkbox group
         */
        "name"?: string;
        /**
          * Set the checkbox as required.
          * @category State
         */
        "required"?: boolean;
        /**
          * If set to true, this checkbox turns into a checkbox-tile.
          * @category Tile
         */
        "tile"?: boolean;
        /**
          * This will be emitted on change and input, like a native checkbox
         */
        "value": string;
    }
    /**
     * The `pn-choice-chip` is built with a native `input[type="checkbox|radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the choice chip state is being toggled. Works for both checkbox/radio variant.
     */
    interface PnChoiceChip {
        /**
          * Precheck the choice chip
         */
        "checked"?: boolean;
        /**
          * A unique HTML id
         */
        "choiceid"?: string;
        /**
          * Disable the choice chip.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Include an icon
         */
        "icon"?: string;
        /**
          * The choice chip label
         */
        "label": string;
        /**
          * Set the size to large.
          * @category Size
         */
        "large"?: boolean;
        /**
          * The name of the checkbox group
         */
        "name"?: string;
        /**
          * Make the choice chip a radio
         */
        "radio"?: boolean;
        /**
          * Set the choice chip as required.
          * @category State
         */
        "required"?: boolean;
        /**
          * Set the size to small.
          * @category Size
         */
        "small"?: boolean;
        /**
          * This will be emitted on change and input
         */
        "value": string;
    }
    /**
     * The `pn-counter` is an input with a button on each side that can be used to increase and decrease the input value.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface PnCounter {
        /**
          * Set a unique HTML ID for the counter
         */
        "counterid"?: string;
        /**
          * Set the counter as disabled.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Set a helpertext for the counter.
         */
        "helpertext"?: string;
        /**
          * Label for the counter
         */
        "label": string;
        /**
          * Text for the decrease button. Default is "Decrease".
          * @category Translation
         */
        "labelDecrease"?: string;
        /**
          * Text for the increase button. Default is "Increase".
          * @category Translation
         */
        "labelIncrease"?: string;
        /**
          * Set the language manually for the built in translations.
         */
        "language"?: PnLanguages;
        /**
          * Suggest values for the counter input.
          * @category HTML input
         */
        "list"?: string;
        /**
          * Maximum value.
          * @category HTML input
         */
        "max"?: number;
        /**
          * Set a message that shows below input when user wants to set a value that is above `max`. Default is "Maximum value is x"
          * @category Translation
         */
        "maxMessage"?: string;
        /**
          * Minimum value.
          * @category HTML input
         */
        "min"?: number;
        /**
          * Set a message that shows below input when user wants to set a value that is below `min`. Default is "Minimum value is x"
          * @category Translation
         */
        "minMessage"?: string;
        /**
          * HTML input name.
          * @category HTML input
         */
        "name"?: string;
        /**
          * Instead of listening to multiple input, change and/or click events, we bundled them into one. - `value` is the current counter value. - `input` is true if the user changed the value with the HTML input. - `decrease` is true if the user clicked on the decrease button. - `increase` is true if the user clicked on the increase button.
         */
        "onCounterInput"?: (event: PnCounterCustomEvent<{ value: number; input?: boolean; decrease?: boolean; increase?: boolean }>) => void;
        /**
          * Set the counter as readonly.
          * @category State
         */
        "readonly"?: boolean;
        /**
          * Set the counter as required.
          * @category State
         */
        "required"?: boolean;
        /**
          * Increase/decrease the value in steps, default is 1.
          * @category HTML input
         */
        "step"?: number;
        /**
          * Set a predefined value
         */
        "value"?: number;
    }
    /**
     * The date picker allows a single or a range of dates to be selected.
     * Based on the `format` prop, separators will automatically be added if you type the date.
     * You can navigate the calendar grid with your keyboard.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface PnDatePicker {
        /**
          * Set the input `autocomplete` attribute.
          * @category HTML attributes
         */
        "autocomplete"?: string;
        /**
          * Make the calendar open upwards by default. Opens downwards if there is not enough space.
          * @category Features
         */
        "calendarUp"?: boolean;
        /**
          * Set a custom ID for the calendar.
          * @category HTML attributes
         */
        "dateId"?: string;
        /**
          * If you use a format with an unknown length, disable the max length.
          * @category Features
         */
        "disableMaxLength"?: boolean;
        /**
          * Disable the automatic insertion of separators when typing in the input.
          * @category Features
         */
        "disableTypeAhead"?: boolean;
        /**
          * Remove the option to select dates on weekends.
          * @category Features
         */
        "disableWeekends"?: boolean;
        /**
          * Set the date picker as disabled.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Individual dates you want to disable. Use a comma separated string.  Remember to use the same format that you have in the `format` prop.
          * @see {@link format }
          * @example "YYYY-MM-DD,YYYY-MM-DD"
          * @category Features
         */
        "disabledDates"?: string;
        /**
          * Set a predefined value for the from date.
          * @see {@link range }
          * @see {@link format }
         */
        "end"?: string;
        /**
          * Placeholder for end date (defaults to the format prop).
          * @see {@link format }
          * @category HTML attributes
         */
        "endPlaceholder"?: string;
        /**
          * Set an error message for the date picker. Overwrites the helpertext if used at the same time.
          * @category Validation
         */
        "error"?: string;
        /**
          * Set the date format of the value.  While you can set any date value from the Dayjs documentation, we strongly recommend you pick a simple format that you can also type manually.
          * @see {@link https://day.js.org/docs/en/display/format Day.js format documentation.}
         */
        "format"?: string;
        /**
          * Provide a helpertext for the date input.
         */
        "helpertext"?: string;
        /**
          * Trigger the invalid state without an error message.
          * @category Validation
         */
        "invalid"?: boolean;
        /**
          * Set a label for the from date.
         */
        "labelFrom": string;
        /**
          * Set a label for the to date.
          * @see {@link range }
         */
        "labelTo"?: string;
        /**
          * Manually set language; this will be inherited from the topbar.
         */
        "language"?: PnLanguages;
        /**
          * Set the input `list` attribute for the first date input.
          * @category HTML attributes
         */
        "list"?: string;
        /**
          * Set the input `list` attribute for the second date input.
          * @category HTML attributes
         */
        "listEnd"?: string;
        /**
          * Latest date possible, this will determine how many years forward the date picker will show.  Remember to use the same format that you have in the `format` prop.
          * @see {@link format }
          * @example "2024-06-25"
          * @category Min/max date
         */
        "maxDate"?: string;
        /**
          * Earliest date possible, this will determine how many years back the date picker will show.  Remember to use the same format that you have in the `format` prop.
          * @see {@link format }
          * @example "2024-05-25"
          * @category Min/max date
         */
        "minDate"?: string;
        /**
          * HTML input name
          * @category HTML attributes
         */
        "name"?: string;
        /**
          * Emmitted when you select a new view.
         */
        "onCurrentView"?: (event: PnDatePickerCustomEvent<CalendarView>) => void;
        /**
          * Emitted when an invalid value is set. This can only be done if the user writes in the input itself.
         */
        "onDateInvalid"?: (event: PnDatePickerCustomEvent<{ start?: string; end?: string }>) => void;
        /**
          * Emits on valid date selection. Either if the user selects a date in the calendar or writes it manually.
         */
        "onDateSelection"?: (event: PnDatePickerCustomEvent<PnDatePickerSelectEvent>) => void;
        /**
          * Use the new `dateSelection`. Its here for compatibility. Will be removed in v8.
          * @deprecated Use the new `dateSelection`. Will be removed in v8.
         */
        "onDateselection"?: (event: PnDatePickerCustomEvent<PnDatePickerSelectEvent>) => void;
        /**
          * Emitted when the calendar is toggled.
         */
        "onToggleCalendar"?: (event: PnDatePickerCustomEvent<boolean>) => void;
        /**
          * Set the HTML pattern prop on the input elements. Make sure it matches the format.
          * @category HTML attributes
         */
        "pattern"?: string;
        /**
          * Placeholder for the input field (defaults to the format prop).
          * @see {@link format }
          * @category HTML attributes
         */
        "placeholder"?: string;
        /**
          * Allow the selection of a date range.
          * @category Features
         */
        "range"?: boolean;
        /**
          * Set a limit on how many days one may select. By default, you can select an unlimited range.
          * @todo Create a range limit function.
          * @see {@link range }
          * @category Features
          * @hide true
         */
        "rangeLimit"?: number;
        /**
          * Set the date picker as readonly.
          * @category State
         */
        "readonly"?: boolean;
        /**
          * Set the date picker as required.
          * @category State
         */
        "required"?: boolean;
        /**
          * Set a predefined value for the from date.
          * @see {@link format }
         */
        "start"?: string;
        /**
          * The calendar grid is shown as default. You can set either `months` or `years` as your first choice.
          * @category Features
         */
        "view"?: CalendarView;
        /**
          * Show weekend numbers to the left of the calendar grid.
          * @category Features
         */
        "weekNumbers"?: boolean;
    }
    /**
     * The fielset is a wrapper to give context and information about inputs. Most commonly, a set of radio/checkboxes.
     * However, you may include any type of input such as textareas, toggles and selects.
     */
    interface PnFieldset {
        /**
          * Disable all of the inputs inside of the fieldset.
         */
        "disabled"?: boolean;
        /**
          * Error message, applies warning styles and icon.
         */
        "error"?: string;
        /**
          * Give the fieldset a custom HTML id.
         */
        "fieldsetId"?: string;
        /**
          * The id of the form you want the fieldset to be part of. If you want the inputs inside to be associated with a specific form, you need to set on those elements directly.
         */
        "form"?: string;
        /**
          * Text message underneath the legend for more instruction or hints on how to fill in controls correctly.
         */
        "helpertext"?: string;
        /**
          * Set the fieldset as `invalid`, will add red error styles.
         */
        "invalid"?: boolean;
        /**
          * The legend provides a caption for the fieldset group. This should be a question or heading that describes the inputs/fields.
         */
        "legend": string;
        /**
          * Give the fieldset a HTML name.
         */
        "name"?: string;
    }
    /**
     * Users can drop files directly into the upload area of the component
     * or simply click on it to open their native file explorer.
     * @nativeChange Use the `change` event to listen when the input receives files.
     * @nativeCancel The `cancel` event lets you know the user canceled their selection.
     * Either via clicking on the "Cancel" button or pressing `ESC`.
     */
    interface PnFileUpload {
        /**
          * Set which file types the input accepts. Ex: .docs,.xml
          * @category HTML attributes
         */
        "accept"?: string;
        /**
          * Use the capture mode.
          * @category HTML attributes
         */
        "capture"?: '' | 'user' | 'environment';
        /**
          * Disable the input.
          * @category HTML attributes
         */
        "disabled"?: boolean;
        /**
          * The helpertext defaults to "Supported formats {x} and max filesize {y}", if there is a value set for the prop `accept`.
         */
        "helpertext"?: string;
        /**
          * Always hide the progress bar, even when upload has begun.
          * @category Features
         */
        "hideProgress"?: boolean;
        /**
          * The default label is "Click or drag a file here".
         */
        "label"?: string;
        /**
          * Manually set the language.
          * @category Features
         */
        "language"?: PnLanguages;
        /**
          * Set maximum amount of files to be selected. Any value above 1 will force the `multiple` to be `true`.
          * @category HTML attributes
         */
        "limit"?: number;
        /**
          * Set the maximum upload size.
          * @category HTML attributes
         */
        "maxSize"?: string;
        /**
          * Allow multiple files to be selected. Will be overwritten to true, if `limit` is above 1.
          * @category HTML attributes
         */
        "multiple"?: boolean;
        /**
          * Set a HTML name.
          * @category HTML attributes
         */
        "name"?: string;
        /**
          * This event is emitted when you add files. Either via drag and drop or using the file explorer.
         */
        "onFilesAdded"?: (event: PnFileUploadCustomEvent<PnUploadFileItem[]>) => void;
        /**
          * If any error occurs, such as: invalid file type, size, limit or error during upload.
         */
        "onFileuploaderror"?: (event: PnFileUploadCustomEvent<Error>) => void;
        /**
          * Emitted everytime an update is made to one of the files.
         */
        "onUpdate"?: (event: PnFileUploadCustomEvent<{ files: PnUploadFileItem[]; element: HTMLPnFileUploadElement }>) => void;
        /**
          * Emitted when an upload has been cancelled before completion.
         */
        "onUploadCancelled"?: (event: PnFileUploadCustomEvent<PnUploadFileItem>) => void;
        /**
          * Emitted once the upload is finished.
         */
        "onUploadCompleted"?: (event: PnFileUploadCustomEvent<PnUploadFileItem[]>) => void;
        /**
          * Emitted once the file upload has begun.
         */
        "onUploadFile"?: (event: PnFileUploadCustomEvent<{
    file: PnUploadFileItem;
    index: number;
    uploader: any;
  }>) => void;
        /**
          * Emitted everytime you select a valid file. It's a good idea to use this event in order to make use of the built in validation features.
         */
        "onValid"?: (event: PnFileUploadCustomEvent<this>) => void;
        /**
          * Set the input as required.
          * @category HTML attributes
         */
        "required"?: boolean;
    }
    /**
     * The default market and language is SE/en.
     * Make sure you set the market **and** language prop.
     * Example: Setting the `language` prop `da` will not display anything, as `da` does not exist on the `SE` market.
     * @deprecated This component has been replaced with the {@link https://portal.postnord.com/web-components/?path=/docs/external-components-pn-footer-nav--docs pn-footer-nav}.
     */
    interface PnFooter {
        /**
          * Set the language for the footer.
         */
        "language"?: PnLanguages;
        /**
          * Set the market for the footer.
         */
        "market"?: PnMarkets;
    }
    interface PnHeader {
        /**
          * The href for the go back link. If this is provided a button be displayed.
         */
        "goBackHref"?: string;
        /**
          * The text for the back link.
         */
        "goBackText"?: string;
        /**
          * Heading text.
         */
        "heading"?: string;
        /**
          * Set the language manually, only use this prop if the pnTopbar is not loaded. Supported: sv, en, da, fi and no.
         */
        "language"?: PnLanguages;
        /**
          * Set a inner container max-width, any width CSS value is accepted.
         */
        "maxWidth"?: string;
    }
    /**
     * The `pn-icon` is a wrapper for an SVG string.
     * While its built with PostNords specific icon dimensions in mind (24x24px), you can use any SVG content in this component.
     * As long as its 3x3 in size, there should be no problem.
     * The color feature will not overwrite the color of flags.
     */
    interface PnIcon {
        /**
          * Color the icon with one of the follwing colors from our library.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-design-tokens-colors--docs PostNord Colors (Storybook)}
         */
        "color"?: PnColors;
        /**
          * The SVG content of the icon you want to use.  Flags cannot be colored.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-design-tokens-icon--docs PostNord Icons (Storybook)}
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-design-tokens-flag--docs PostNord Flags (Storybook)}
         */
        "icon"?: string;
        /**
          * Make the icon small (16 instead of 24px).
         */
        "small"?: boolean;
    }
    interface PnIllustration {
        /**
          * Make the SVG fill to its parent size (sets width/height 100% and `display: block` instead of `inline-block`)
         */
        "fill"?: boolean;
        /**
          * Set the height of the SVG element. Any valid CSS height value is allowed
         */
        "height"?: string;
        /**
          * The SVG content of the illustration you want to use. The viewBox property will be used to determine width/height
         */
        "illustration": string;
        /**
          * Set the width of the SVG element. Any valid CSS width value is allowed
         */
        "width"?: string;
    }
    /**
     * The `pn-input` is a regular `input` but styled. This means you can use native events to listen to the changes.
     * Always use the `label` prop to make sure the input is accessible.
     * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
     * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
     */
    interface PnInput {
        /**
          * Set the ID of what this input controls.
          * @category HTML input
         */
        "ariacontrols"?: string;
        /**
          * While you can use the `aria-label`, using a `label` is far more accessible.
          * @category HTML input
         */
        "arialabel"?: string;
        /**
          * Let the browser know what type of autocorrects the input should use. Works much better if a `name` and `inputid` is supplied.
          * @see {@link name }
          * @see {@link inputid }
          * @category HTML input
         */
        "autocomplete"?: string;
        /**
          * Set the input as `disabled`.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Set the input as `invalid` and display an error message (applies the same style as `invalid`).  Error message; will take precedence over helpertext if both are provided.
          * @see {@link invalid Set invalid without an error message.}
          * @category Validation
         */
        "error"?: string;
        /**
          * Text message placed underneath the input field.
         */
        "helpertext"?: string;
        /**
          * Select an icon to display before the input field value. `icon` takes precedence over the `text-prefix` prop.
          * @see {@link textPrefix }
          * @category Visual
         */
        "icon"?: string;
        /**
          * Provide a unique HTML id to connect the input with the label. A unique uuid ID will be generated if this field is left empty.
         */
        "inputid"?: string;
        /**
          * Hint the browser about what type of virtual keyboard should be used. The browser will be able to decide this on its own most of the time, especially if you use the `type`, `name` and `inputid` props.  Leave empty or with a `''` value if you want the browsers default behaviour (`text`).
          * @category HTML input
         */
        "inputmode"?: 'text' | 'none' | 'decimal' | 'numeric' | 'tel' | 'search' | 'email' | 'url';
        /**
          * Set the input as `invalid`. Provides a red color and red warning icon.
          * @see {@link error Provide an error message.}
          * @category Validation
         */
        "invalid"?: boolean;
        /**
          * Text label placed above the input field.
         */
        "label": string;
        /**
          * Set the language manually for the translations of show/hide/clear button text. Not needed if you have the pntopbar on the page.
         */
        "language"?: PnLanguages;
        /**
          * Point to a datalist element for this input.
          * @category HTML input
         */
        "list"?: string;
        /**
          * Set the `max` value of the `number` input.
          * @category HTML input
         */
        "max"?: number | string;
        /**
          * The maximum number of characters the user should be able to add, also adds a visible counter.
          * @category HTML input
         */
        "maxlength"?: number;
        /**
          * Set the `min` value of the `number` input.
          * @category HTML input
         */
        "min"?: number | string;
        /**
          * HTML input name. Setting a name will help the browser understand what type of data the input have and can better assist with autofill data based on previous entires much better.
          * @category HTML input
         */
        "name"?: string;
        /**
          * Pattern prop.
          * @category HTML input
         */
        "pattern"?: string;
        /**
          * Provide a placeholder text. Remember that this is no replacement for a label. The placeholder should be a nice addition to the label/helpertext, not important information.
          * @category HTML input
         */
        "placeholder"?: string;
        /**
          * Set the input as `readonly`.
          * @category State
         */
        "readonly"?: boolean;
        /**
          * Set the input as `required`.
          * @category State
         */
        "required"?: boolean;
        /**
          * Set a `step` for the number input.
          * @category HTML input
         */
        "step"?: number | string;
        /**
          * Set a small text before the input field value. Cannot be used together with an `icon` at the same time.
          * @see {@link icon }
          * @see {@link textSuffix }
          * @category Visual
         */
        "textPrefix"?: string;
        /**
          * Set a small text after the input field value. Cannot be used with the `text-prefix` prop at the same time.
          * @see {@link textPrefix }
          * @category Visual
         */
        "textSuffix"?: string;
        /**
          * pn-input supports: `text`, `password`, `url`, `tel`, `search`, `number` & `email`.
          * @category HTML input
         */
        "type"?: 'text' | 'password' | 'url' | 'tel' | 'search' | 'number' | 'email' | '';
        /**
          * Set the input as `valid`. Provides a green color and a check icon.
          * @category Validation
         */
        "valid"?: boolean;
        /**
          * Set the value of the input.
         */
        "value"?: string;
    }
    /**
     * Present content in a modal that overlays everything on the current page.
     * Use the prop `open` to toggle the visiblity.
     * Use the event `close` to determine when the modal is being closed by the user.
     */
    interface PnModal {
        /**
          * Event fired when the modal is closed, either by clicking on the dark background or by clicking on the close button.
         */
        "onClose"?: (event: PnModalCustomEvent<boolean>) => void;
        /**
          * Bind to this property if you want to control the visibility of the modal from your own data.
         */
        "open"?: boolean;
    }
    /**
     * The `pn-multiselect` gets its options via javascript.
     * Native HTML does not accept arrays of objects. Most frameworks solves this automatically (Vue, react, etc...),
     * but keep this in mind if you use this component outside of a framework environment.
     * @nativeChange The `pn-multiselect` is built with `input[type=checkbox]` elements, so the `change` event works. However, we recommend the customEvents described above.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-input-multiselect--docs#pn-multiselect%20(options) Options documentation}
     */
    interface PnMultiselect {
        /**
          * Set a custom value for the "Select all value" option.
          * @see {@link selectAll }
          * @category Features
         */
        "allValue"?: string;
        /**
          * Force the dropdown to always open downwards.
          * @category Features
         */
        "bottom"?: boolean;
        /**
          * Disable the select.
          * @category Validation
         */
        "disabled"?: boolean;
        /**
          * Display an error message and trigger the invalid state.
          * @category Validation
         */
        "error"?: string;
        /**
          * Display a helper text underneath the select
         */
        "helpertext"?: string;
        /**
          * Display an icon to the left of the select input
         */
        "icon"?: string;
        /**
          * Trigger the invalid state.
          * @category Validation
         */
        "invalid"?: boolean;
        /**
          * Decide how many items should be shown before ellipsis. Requires the `search` prop to work.
          * @see {@link search }
          * @category Features
         */
        "itemCount"?: number;
        /**
          * Label placed above the select
         */
        "label": string;
        /**
          * Manually set the language, not needed if you have the pnTopbar available
         */
        "language"?: PnLanguages;
        /**
          * Use a custom max-height for the dropdown list.
          * @description The component will automatically set the max height of the dropdown list on its own. It takes the `pn-topbar` into account and will open in the direction that fits best. Use this prop to override this behaviour and use a custom max-height.
          * @category Features
         */
        "maxHeight"?: string;
        /**
          * HTML name of the checkbox elements. Used for each checkbox inside the multiselect.
         */
        "name"?: string;
        /**
          * This event contains the entire options array with the new props. Dispatched everytime you make changes to any option.
         */
        "onAllOptions"?: (event: PnMultiselectCustomEvent<PnMultiselectOption[]>) => void;
        /**
          * Contains the search text and the options found for that query. Dispacthed everytime you change the search query.
         */
        "onSearchInput"?: (event: PnMultiselectCustomEvent<{
    query: string;
    found?: PnMultiselectOption[];
  }>) => void;
        /**
          * This event is dispatched when the user toggles the "Choose all options" box. Also triggers when you click the "Select {number} options" if you are performing a search at the same time.
         */
        "onSelectedAllOptions"?: (event: PnMultiselectCustomEvent<{
    checked: boolean;
    searching: boolean;
    query?: string;
    found?: PnMultiselectOption[];
  }>) => void;
        /**
          * Dispatched when you toggle an option. Includes all the props of the option.
         */
        "onSelectedOption"?: (event: PnMultiselectCustomEvent<PnMultiselectOption>) => void;
        /**
          * Dispatched everytime the multiselect is opened or closed.
         */
        "onToggleSelect"?: (event: PnMultiselectCustomEvent<{ open: boolean }>) => void;
        /**
          * Array of options.
          * @hide true
         */
        "options": PnMultiselectOption[];
        /**
          * This is what will be shown on load if no value is used. The `placeholder` will override the default text used if you have the `search` prop active.
         */
        "placeholder"?: string;
        /**
          * Set the select as required.
          * @category Validation
         */
        "required"?: boolean;
        /**
          * Allow the user to search among the options. The selected options will now display underneath the multiselect element.
          * @category Features
         */
        "search"?: boolean;
        /**
          * Set the search query of the multiselect.
          * @see {@link search }
          * @category Features
         */
        "searchQuery"?: string;
        /**
          * Adds a "Select all" option into the list. If you use the search feature at the same time, clicking this option will only toggle the options found.
          * @see {@link search }
          * @category Features
         */
        "selectAll"?: boolean;
        /**
          * Select HTML id
         */
        "selectId"?: string;
        /**
          * HTML name of the input element.
         */
        "selectName"?: string;
        /**
          * Force the dropdown to always open upwards.
          * @category Features
         */
        "top"?: boolean;
    }
    interface PnOcrSearch {
        /**
          * The `language` property will be prioritized before the pnTopbar language.
         */
        "language"?: PnLanguages;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface PnPageNav {
        /**
          * Pass a string which will be the text on the dropdown button.
         */
        "dropdown"?: string | boolean;
        /**
          * Set a unique HTML ID.
         */
        "navid"?: string;
        /**
          * Emits the value of the selected item.
         */
        "onNavchange"?: (event: PnPageNavCustomEvent<string>) => void;
        /**
          * Currently active menu item value
         */
        "value"?: string;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface PnPageNavDropdownItem {
        /**
          * Ignore this, it's internal communication with parent.
          * @hide true
         */
        "active"?: boolean;
        /**
          * Pass an href to the items if you want to have links that lead outside of your app
         */
        "href"?: string;
        /**
          * Ignore this, it's internal communication with parent
         */
        "onItemselection"?: (event: PnPageNavDropdownItemCustomEvent<string>) => void;
        /**
          * The value that will be emitted upon selection, only pass this if the item is a link, if you want a button (for quick actions), omit this prop.
         */
        "value": string;
    }
    /**
     * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
     */
    interface PnPageNavItem {
        /**
          * Pass an href to the items if you want to have links that lead outside of your app.
         */
        "href"?: string;
        /**
          * The SVG content of the icon you want.
         */
        "icon"?: string;
        /**
          * Event is emitted when you select an item.
         */
        "onItemselection"?: (event: PnPageNavItemCustomEvent<string>) => void;
        /**
          * The item value. Used by `pn-page-nav` to determine pre-selected item.
         */
        "value": string;
    }
    /**
     * Accessible pagination needs each item to link to a different part of the document.
     * This means that you must `preventDefault` on the `MouseEvent` emitted from the `pageSelected` event if you have a SPA.
     * If you set a `page` value that is higher than `pages`, the component will automatically lower it to the `pages` value.
     */
    interface PnPagination {
        /**
          * Set a label for the pagination element for screen readers. It defaults to `Pagination`.
         */
        "label"?: string;
        /**
          * Manually set the language.
         */
        "language"?: PnLanguages;
        /**
          * Emitted when the page is changed. Either via clicking a link or selecting a page in the select.
         */
        "onPageSelected"?: (event: PnPaginationCustomEvent<{ page: number; mouse: MouseEvent }>) => void;
        /**
          * This event fires when the user changes how many items should be shown per page.
         */
        "onRowsSelected"?: (event: PnPaginationCustomEvent<{ rows: number; change: Event }>) => void;
        /**
          * Set which page the user is currently viewing. Use this to set an inital page or if the selected page is changed from outside this component.
          * @category Pages
         */
        "page"?: number;
        /**
          * Set how many pages are available.
          * @category Pages
         */
        "pages": number;
        /**
          * Set how many pages should be visible at one time. Use an odd number. Minimum is `5`.
          * @category Pages
         */
        "pagesVisible"?: number;
        /**
          * Set a HTML id on the pagination element.
         */
        "paginationId"?: string;
        /**
          * Allow the user to decide how many items should be shown per page. Make sure this value exists in the `rowsList` string.
          * @see {@link rowsList }
          * @category Rows per page
         */
        "rows"?: number;
        /**
          * Default label is "Items per page".
          * @see {@link rows }
          * @category Rows per page
         */
        "rowsLabel"?: string;
        /**
          * Set available items per page options the user can select. Use a comma separated string.
          * @see {@link rows }
          * @category Rows per page
         */
        "rowsList"?: string;
        /**
          * Set a custom URL template. Use `{page}` within the string to position where the dynamic page number should be.
         */
        "urlTemplate"?: string;
    }
    interface PnProgressBar {
        /**
          * Trigger an error and display a message
         */
        "error"?: string;
        /**
          * Set a label for the progress bar
         */
        "label"?: string;
        /**
          * Progress value, 0-100
         */
        "progress"?: number;
        /**
          * A unique HTML id fror the progress bar
         */
        "progressId"?: string;
        /**
          * Replaces the default progress percentage text
         */
        "progressText"?: string;
        /**
          * Text shown on success (100%)
         */
        "successText"?: string;
    }
    interface PnProgressIndicator {
        /**
          * Takes the index of the active step
         */
        "activeStep"?: number;
        /**
          * This will emit when progress is changed and is the value you want to bind to your VM state
         */
        "onProgresschange"?: (event: PnProgressIndicatorCustomEvent<number>) => void;
    }
    interface PnProgressIndicatorStep {
        /**
          * Set by the parent component. Do not use manually.
          * @hide true
         */
        "active"?: 'yes' | 'no';
        /**
          * Set by the parent component. Do not use manually.
          * @hide true
         */
        "activeStep"?: number;
        /**
          * Set the step as checked, meaning a white check mark will appear.
         */
        "checked"?: boolean;
        /**
          * Set by the parent component. Do not use manually.
          * @hide true
         */
        "index"?: number;
        /**
          * The step name.
         */
        "name"?: string;
        "onSetactivestep"?: (event: PnProgressIndicatorStepCustomEvent<number>) => void;
    }
    /**
     * The `pn-progress-stepper` is used to visualize the users progress through a flow (checkout/survey, etc...).
     */
    interface PnProgressStepper {
        /**
          * The current step of the progress stepper.
         */
        "currentStep"?: PnSteps;
        /**
          * Set custom label for the stepper, recommended default label is "Step".
         */
        "label"?: string;
        /**
          * Set the language manually, only use this prop if the pnTopbar is not loaded. Will not overwrite the `label` prop if used.
         */
        "language"?: PnLanguages;
        /**
          * Set a custom HTML id on the progress stepper element to associate progress bar with label.
         */
        "progressStepperId"?: string;
        /**
          * You can add a custom optional string to the label if you need a name for the current step.
         */
        "stepName"?: string;
        /**
          * Set total amount of steps, maximum `7` is allowed.
         */
        "totalSteps"?: PnSteps;
    }
    /**
     * The `pn-radio-button` is built with a native `input[type="radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the radio state is being changed.
     */
    interface PnRadioButton {
        /**
          * Check the radio button
         */
        "checked"?: boolean;
        /**
          * Disable the radio button.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * With this prop you can add an optional helper text element to radio button.
         */
        "helpertext"?: string;
        /**
          * Add an icon on the right of your radio tile. The `tile` prop must be `true` for the icon to work.
          * @category Tile
         */
        "icon"?: string;
        /**
          * Trigger the red error state.
          * @category State
         */
        "invalid"?: boolean;
        /**
          * The radio button label
         */
        "label"?: string;
        /**
          * The name of the radio button group that will hold this button, like a native radio button (required)
         */
        "name"?: string;
        /**
          * Give the radio button a custom ID
         */
        "radioid"?: string;
        /**
          * Set the radio button as required.
          * @category State
         */
        "required"?: boolean;
        /**
          * Turn this radio-button into a radio-tile.
          * @category Tile
         */
        "tile"?: boolean;
        /**
          * This will be emitted on `change` and `input`, like a native radio button (required)
         */
        "value": string;
    }
    /**
     * There are no events or features other than the `icon`, `small` and `language` prop.
     * Our rule is to not have disabled buttons.
     * However, this component is an exception for a very specific use case regarding portal users.
     */
    interface PnReadOnlyButton {
        /**
          * The SVG content of the icon you want.
         */
        "icon"?: string;
        /**
          * If you're using a button with only an icon, button text is still REQUIRED for the tooltip.
         */
        "iconOnly"?: boolean;
        /**
          * Set the language manually.
         */
        "language"?: PnLanguages;
        /**
          * Icon on the left side instead of on the right.
         */
        "leftIcon"?: boolean;
        /**
          * Smaller button.
         */
        "small"?: boolean;
    }
    interface PnSearchField {
        /**
          * Allow the browser to autocomplete the search field.
         */
        "autocomplete"?: string;
        /**
          * Button type, options are `none` for no button, `icon` for a labelless button with just a search icon and `icon-inline` for a search button inside of the search field (this last option disables the clear field button).
          * @category Button
         */
        "button"?: '' | 'none' | 'icon' | 'icon-inline';
        /**
          * Label for the button element.
          * @category Button
         */
        "buttonLabel"?: string;
        /**
          * Light instead of dark search button.
          * @category Button
         */
        "buttonLight"?: boolean;
        /**
          * Disable the search field.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Provide an aria-label for the search field.
         */
        "label": string;
        /**
          * Override the pntopbar language.
         */
        "language"?: PnLanguages;
        /**
          * Point to a datalist element with this id.
         */
        "list"?: string;
        /**
          * Display loading animation.
          * @category State
         */
        "loading"?: boolean;
        /**
          * Set HTML name of the search input.
         */
        "name"?: string;
        /**
          * This is emitted on search submission both with keyboard and mouse.
         */
        "onSearch"?: (event: PnSearchFieldCustomEvent<string>) => void;
        /**
          * Custom event that handles both clearing and input to have the option of just binding listeners to one event instead of two.
         */
        "onUpdate"?: (event: PnSearchFieldCustomEvent<string>) => void;
        /**
          * Set a search field placeholder.
         */
        "placeholder"?: string;
        /**
          * Set the search field as required.
          * @category State
         */
        "required"?: boolean;
        /**
          * Set a unique ID for the search input
         */
        "searchid"?: string;
        /**
          * Set the value of the search field.
         */
        "value"?: string;
    }
    /**
     * The `pn-segment` is built with a native `input[type="radio"]` in the background.
     * Do not listen to events on the `pn-segment`, but on the `pn-segmented-control` instead.
     */
    interface PnSegment {
        /**
          * Disable the segment.
         */
        "disabled"?: boolean;
        /**
          * The SVG content of the icon you want.
         */
        "icon"?: string;
        /**
          * The segment label, same as the slot.
         */
        "label"?: string;
        /**
          * The segment controller name.
         */
        "name": string;
        /**
          * This event is used by the `pn-segmented-control` component. Do not use manually.
         */
        "onSegmentHover"?: (event: PnSegmentCustomEvent<MouseEvent>) => void;
        /**
          * A unique HTML id.
         */
        "segmentid"?: string;
        /**
          * Set the segment as selected. Used by the `pn-segmented-control`. **Do not use manually**.
          * @hide true
         */
        "selected"?: boolean;
        /**
          * The segment value.
         */
        "value": string;
    }
    /**
     * The `pn-segmented-control` and `pn-segmented` is built with native `input[type="radio"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the segment state is being changed.
     */
    interface PnSegmentedControl {
        /**
          * This is the name of the radio buttons inside the controller.
          * @deprecated Set the name in the nested `pn-segment` components.
         */
        "name": string;
        /**
          * Currently active segment value.
         */
        "value"?: string;
    }
    /**
     * The `pn-select` uses a native `select` element under the hood.
     * Use the slot to include `option` elements.
     * Just like a regular `select`, you can use the `selected` prop on the nested option elements to preselect an option.
     * @nativeChange Use the `change` event to listen to changes on the select element.
     */
    interface PnSelect {
        /**
          * HTML autocomplete.
          * @category HTML
         */
        "autocomplete"?: string;
        /**
          * Disable the select.
          * @category Validation
         */
        "disabled"?: boolean;
        /**
          * Display an error message and trigger the invalid state.
          * @category Validation
         */
        "error"?: string;
        /**
          * HTML form name.
          * @category HTML
         */
        "form"?: string;
        /**
          * Display a helper text underneath the select.
         */
        "helpertext"?: string;
        /**
          * Display an icon to the left of the select input.
         */
        "icon"?: string;
        /**
          * Trigger the invalid state.
          * @category Validation
         */
        "invalid"?: boolean;
        /**
          * Label placed above the select.
         */
        "label": string;
        /**
          * HTML select name.
          * @category HTML
         */
        "name"?: string;
        /**
          * Set the select as required.
          * @category Validation
         */
        "required"?: boolean;
        /**
          * Select HTML id
         */
        "selectId"?: string;
    }
    interface PnSpinner {
        /**
          * Light version of the spinner
         */
        "light"?: boolean;
        /**
          * Size in em
         */
        "size"?: number;
    }
    interface PnTab {
        /**
          * Is set by `pn-tablist`, don't use this prop.
          * @hide true
         */
        "activeTab"?: string;
        /**
          * Use the ID of the container that this tab controls.
         */
        "ariacontrols"?: string;
        /**
          * Turns the tab from a `button` to an `a` element, but only if the `pn-tablist` is inside a `pn-header`.
         */
        "href"?: string;
        /**
          * The SVG content of the icon you want to display
         */
        "icon"?: string;
        /**
          * Set a label for the tab.
         */
        "label": string;
        /**
          * Used by `pn-tab` to communicate with `pn-tablist`. Emits the selected tab value and element.
         */
        "onSetActiveTab"?: (event: PnTabCustomEvent<{ val: string; el: HTMLPnTabElement }>) => void;
        /**
          * Used by `pn-tab` to communicate with `pn-tablist`. Emits when the tab gets focus.
         */
        "onTabEnter"?: (event: PnTabCustomEvent<MouseEvent | FocusEvent>) => void;
        /**
          * Used by `pn-tab` to communicate with `pn-tablist`. Emits when the tab is blured.
         */
        "onTabLeave"?: (event: PnTabCustomEvent<MouseEvent | FocusEvent>) => void;
        /**
          * Tab ID, use if you want to have the tab container be `aria-labelledby` by this tab.
         */
        "tabid"?: string;
        /**
          * This is the value that will be matched with `pn-tablist` value. (required)
         */
        "value": string;
    }
    /**
     * The `pn-table` component is just a wrapper for your HTML table element.
     * You need to create the markup, but the component will deal with the styling.
     * We have a built in class for divs inside table colums called `column-wrapper`.
     * This will line up your content and provide a grid gap.
     */
    interface PnTable {
        /**
          * Add border to table.
         */
        "bordered"?: boolean;
        /**
          * Use the gray variant instead of blue.
         */
        "gray"?: boolean;
        /**
          * Make the table striped.
         */
        "striped"?: boolean;
    }
    interface PnTablist {
        /**
          * Give the tablist a name for screenreaders
         */
        "label": string;
        /**
          * Manually set the language.
         */
        "language"?: PnLanguages;
        /**
          * This will emit when a tab is changed. The detail property of the event will contain the value of the selected tab. This is the event and value you listen to when you toggle the visibility among your tabpanels.
         */
        "onTabchange"?: (event: PnTablistCustomEvent<string>) => void;
        /**
          * Make the tablist smaller
         */
        "small"?: boolean;
        /**
          * Icons are stacked vertically instead of the default rows
         */
        "stackedicons"?: boolean;
        /**
          * The value of the tab that is currently active, each `<pn-tab value="example-value">` also expects a unique value
         */
        "value": string;
    }
    /**
     * The `pn-tag` is a non-interactive visual marker designed to emphasize important aspects of an item, such as its status.
     */
    interface PnTag {
        /**
          * Set tag appearance: `discrete`, `positive`, `warning` & `error`.
          * @category Visual
         */
        "appearance"?: '' | 'discrete' | 'positive' | 'warning' | 'error';
        /**
          * Set darker background-color on the tag.  This is intended for better tag visibility on colored background.
          * @category Visual
          * @deprecated Will be removed in v8.0.0
         */
        "dark"?: boolean;
        /**
          * Select icon from out `pn-design-assets` list. Works with any SVG content.  **Please note**: Can not be used with the `xsmall` prop due to the small size.
          * @see {@link https://portal.postnord.com/web-components/?path=/docs/docs-assets--docs Get started with PostNord assets.}
         */
        "icon"?: string;
        /**
          * The label of the tag.
         */
        "label": string;
        /**
          * Set larger tag.
          * @category Size
         */
        "large"?: boolean;
        /**
          * Set smaller tag.
          * @category Size
         */
        "small"?: boolean;
        /**
          * Set extra small tag.
          * @category Size
         */
        "xsmall"?: boolean;
    }
    /**
     * The `pn-text-link` is a styled `a` element with some extra functionality built in. Such as `icon` and `light` support.
     */
    interface PnTextLink {
        /**
          * Treat the link as a download link.
          * @category Link attributes
         */
        "download"?: string;
        /**
          * The URL string.
         */
        "href": string;
        /**
          * Set the hreflang of the URL destination.
          * @category Link attributes
         */
        "hreflang"?: string;
        /**
          * SVG content of the icon.
          * @category Visual
         */
        "icon"?: string;
        /**
          * The link text.
         */
        "label"?: string;
        /**
          * Align the icon on the left.
          * @category Visual
         */
        "leftIcon"?: boolean;
        /**
          * Use the light version of the link.
          * @category Visual
         */
        "light"?: boolean;
        /**
          * Set a unique html ID of the a element.
          * @category Link attributes
         */
        "linkid"?: string;
        /**
          * Link media.
          * @category Link attributes
         */
        "media"?: string;
        /**
          * Set referrerpolicy on the link.
          * @category Link attributes
         */
        "referrerpolicy"?: ReferrerPolicy;
        /**
          * Set the rel of the link.
          * @category Link attributes
         */
        "rel"?: string;
        /**
          * Set the target of the link.
          * @category Link attributes
         */
        "target"?: string;
    }
    /**
     * The `pn-textarea` is built with a native `textarea`.
     * This means you can use native events to listen to the input.
     * @nativeInput Use the `input` event to listen to content being modified by the user.
     */
    interface PnTextarea {
        /**
          * Allow the browser to autocomplete the textarea.
          * @category HTML Textarea
         */
        "autocomplete"?: string;
        /**
          * Set the col count for the textarea.
          * @category HTML Textarea
         */
        "cols"?: number;
        /**
          * Disable the textarea.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Same as `invalid`, but will display the string as an error message under the textarea.
          * @category State
         */
        "error"?: string;
        /**
          * Set the associated form.
          * @category HTML Textarea
         */
        "form"?: string;
        /**
          * Helper text that will appear underneath the textarea. Will be overwritten if you set an `error` string
         */
        "helpertext"?: string;
        /**
          * Set the textarea as `invalid`, will make the Label and focus rings red.
          * @category State
         */
        "invalid"?: boolean;
        /**
          * The label describing the textarea.
         */
        "label": string;
        /**
          * The maximum number of characters the user should be able to add, also adds a visible counter.
          * @category HTML Textarea
         */
        "maxlength"?: number;
        /**
          * HTML name.
          * @category HTML Textarea
         */
        "name"?: string;
        /**
          * Placeholder for the textarea.
          * @category HTML Textarea
         */
        "placeholder"?: string;
        /**
          * Make the textarea readonly.
          * @category State
         */
        "readonly"?: boolean;
        /**
          * Make the textarea required.
          * @category HTML Textarea
         */
        "required"?: boolean;
        /**
          * Allow the user to resize the textarea vertically. Handle width in your own layout.
          * @category HTML Textarea
         */
        "resize"?: boolean;
        /**
          * Set the row count for the textarea.
          * @category HTML Textarea
         */
        "rows"?: number;
        /**
          * Allow the browser to spellcheck the textarea.
          * @category HTML Textarea
         */
        "spellcheck"?: boolean;
        /**
          * A unique ID connecting the element to the label.
          * @category HTML Textarea
         */
        "textareaid"?: string;
        /**
          * Set the textarea as `valid`, will make the Label and focus rings green.
          * @category State
         */
        "valid"?: boolean;
        /**
          * The textarea content, do not provide slotted content.
         */
        "value"?: string;
        /**
          * Set the wrap control.
          * @category HTML Textarea
         */
        "wrap"?: string;
    }
    /**
     * The `pn-tile` is a navigational element that is intended to be accompanied by an illustration.
     * It is very important that you use the `label` and `url`. This component renders an `a` element if the URL prop is set,
     * so you do not need to wrap or nest the tile in another `a` element. Doing so makes the component inaccessible.
     */
    interface PnTile {
        /**
          * Use the horizontal tile.
          * @category Layout
         */
        "horizontal"?: boolean;
        /**
          * The SVG content of a decorative icon.
          * @category Image
         */
        "icon"?: string;
        /**
          * The SVG content of an illustration.
          * @category Image
         */
        "illustration"?: string;
        /**
          * Label of the link. This is required for the component to be accessible.
         */
        "label": string;
        /**
          * Emitted when the link is clicked. Use the `click` property to `preventDefault` if you wish to perform the navigation programmatically.
         */
        "onPnTile"?: (event: PnTileCustomEvent<{ click: MouseEvent }>) => void;
        /**
          * The rel attribute of the link.
          * @category href
         */
        "rel"?: string;
        /**
          * The target attribute of the link.
          * @category href
         */
        "target"?: string;
        /**
          * Set a string of text for the tile. Same as the default slot.
         */
        "text"?: string;
        /**
          * The link of the tile. This is required for the component to be accessible.
          * @category href
         */
        "url": string;
    }
    /**
     * This component is able to fill many roles of a classic toast.
     * It has 4 different colors, a temporary state, hide button, icon and illustration support.
     * The `pn-toast` will expand to its parent containers full width.
     * Either limit the parent width or set a CSS rule to your specific width if needed.
     */
    interface PnToast {
        /**
          * Default color is blue, you also have the option of success (green), warning (orange) and error (red).
          * @category Visual
         */
        "appearance"?: '' | 'success' | 'warning' | 'error';
        /**
          * Show close button.
          * @category Features
         */
        "closable"?: boolean;
        /**
          * Set a title for the toast. Requires the `text` prop in order to work.
          * @description Can be used together with slotted content.
         */
        "heading"?: string;
        /**
          * Control the visibility of the toast. If the `closable` prop is active, the toast will set the `hide` prop on its own.
          * @see {@link closable }
          * @category Features
         */
        "hide"?: boolean;
        /**
          * Set an SVG icon.
          * @category Visual
         */
        "icon"?: string;
        /**
          * Set an SVG illustration.
          * @category Visual
         */
        "illustration"?: string;
        /**
          * Manually set the language, only needed if the `closable` prop is enabled.
          * @see {@link closable }
          * @category Features
         */
        "language"?: PnLanguages;
        /**
          * Event fired when the close button is pressed.
         */
        "onClose"?: (event: PnToastCustomEvent<boolean>) => void;
        /**
          * This event is fired when the toast is fully hidden after the animation is finished. Triggers from the close button or if the prop `hide` is set to true.
         */
        "onHidden"?: (event: PnToastCustomEvent<boolean>) => void;
        /**
          * This will apply a shadow and border to the toast.
          * @category Visual
         */
        "temporary"?: boolean;
        /**
          * Set a paragraph of text for the toast.
          * @description Can be used together with slotted content.
         */
        "text"?: string;
        /**
          * Give the toast a HTML ID.
         */
        "toastId"?: string;
    }
    /**
     * The `pn-toggle-switch` is built with a native `input[type="checkbox"]` in the background.
     * This means you can use native events to listen to the changes.
     * @nativeChange Use the `change` event to listen when the switch state is being toggled.
     */
    interface PnToggleSwitch {
        /**
          * Precheck the toggle.
         */
        "checked"?: boolean;
        /**
          * Disable the toggle.
          * @category State
         */
        "disabled"?: boolean;
        /**
          * Provide a helpertext for the toggle switch.
         */
        "helpertext"?: string;
        /**
          * A label for the toggle switch.
         */
        "label": string;
        /**
          * Make the toggle larger.
          * @category Visual
         */
        "large"?: boolean;
        /**
          * Set the loading state.
          * @category State
         */
        "loading"?: boolean;
        /**
          * HTML toggle name.
          * @category HTML
         */
        "name"?: string;
        /**
          * Make the toggle smaller.
          * @category Visual
         */
        "small"?: boolean;
        /**
          * Set a unique HTML id.
         */
        "toggleid"?: string;
        /**
          * HTML toggle value.
          * @category HTML
         */
        "value"?: string;
    }
    /**
     * The `pn-tooltip` can display slotted HTML content or a text `string` with the `tooltip` prop.
     * Remember that the component is techincally a `button` element, don't put any HTML content that would be out of place in a regular button
     * (no headlines, other input elements, etc...).
     */
    interface PnTooltip {
        /**
          * Apply the light color if you use a dark background.
         */
        "light"?: boolean;
        /**
          * Overrides the slotted content to create a small tooltip instead.
         */
        "tooltip"?: string;
        /**
          * Apply the warning color and change the icon to `!`.
         */
        "warning"?: boolean;
    }
    /**
     * Check the delivery date for letters, newspapers and direct mail that are distributed every second day.
     */
    interface PnZipcodeSearch {
        /**
          * The `language` property will be prioritized before the pnTopbar language.
         */
        "language"?: PnZipCodeSearchLanguages;
        /**
          * Event fired when search has result
         */
        "onSearchsuccessful"?: (event: PnZipcodeSearchCustomEvent<boolean>) => void;
        /**
          * Set a pre initialized value.
         */
        "value"?: string;
    }
    interface IntrinsicElements {
        "pn-accordion": PnAccordion;
        "pn-accordion-row": PnAccordionRow;
        "pn-button": PnButton;
        "pn-button-dropdown": PnButtonDropdown;
        "pn-card": PnCard;
        "pn-checkbox": PnCheckbox;
        "pn-choice-chip": PnChoiceChip;
        "pn-counter": PnCounter;
        "pn-date-picker": PnDatePicker;
        "pn-fieldset": PnFieldset;
        "pn-file-upload": PnFileUpload;
        "pn-footer": PnFooter;
        "pn-header": PnHeader;
        "pn-icon": PnIcon;
        "pn-illustration": PnIllustration;
        "pn-input": PnInput;
        "pn-modal": PnModal;
        "pn-multiselect": PnMultiselect;
        "pn-ocr-search": PnOcrSearch;
        "pn-page-nav": PnPageNav;
        "pn-page-nav-dropdown-item": PnPageNavDropdownItem;
        "pn-page-nav-item": PnPageNavItem;
        "pn-pagination": PnPagination;
        "pn-progress-bar": PnProgressBar;
        "pn-progress-indicator": PnProgressIndicator;
        "pn-progress-indicator-step": PnProgressIndicatorStep;
        "pn-progress-stepper": PnProgressStepper;
        "pn-radio-button": PnRadioButton;
        "pn-read-only-button": PnReadOnlyButton;
        "pn-search-field": PnSearchField;
        "pn-segment": PnSegment;
        "pn-segmented-control": PnSegmentedControl;
        "pn-select": PnSelect;
        "pn-spinner": PnSpinner;
        "pn-tab": PnTab;
        "pn-table": PnTable;
        "pn-tablist": PnTablist;
        "pn-tag": PnTag;
        "pn-text-link": PnTextLink;
        "pn-textarea": PnTextarea;
        "pn-tile": PnTile;
        "pn-toast": PnToast;
        "pn-toggle-switch": PnToggleSwitch;
        "pn-tooltip": PnTooltip;
        "pn-zipcode-search": PnZipcodeSearch;
    }
}
export { LocalJSX as JSX };
declare module "@stencil/core" {
    export namespace JSX {
        interface IntrinsicElements {
            /**
             * The `pn-accordion` is a wrapper for `pn-accordion-row` components.
             * This component gives the accordion rows some space between each one and provides the `single` feature.
             * Which will force the rule that only a single row to be open at one time.
             */
            "pn-accordion": LocalJSX.PnAccordion & JSXBase.HTMLAttributes<HTMLPnAccordionElement>;
            /**
             * Use this row component inside a `pn-accordion` to create an accordion group.
             * **Note**: you can use the `pn-accordion-row` without the parent accordion.
             * But you will have to style the gap between each row.
             */
            "pn-accordion-row": LocalJSX.PnAccordionRow & JSXBase.HTMLAttributes<HTMLPnAccordionRowElement>;
            /**
             * The `pn-button` is built with a native `button` or `a` element, if you use the `href` attribute.
             * @nativeClick Use the `click` event to listen when the button is clicked.
             */
            "pn-button": LocalJSX.PnButton & JSXBase.HTMLAttributes<HTMLPnButtonElement>;
            /**
             * The open/closing of the dropdown is handled by the component itself.
             * @nativeClick Use the `click` event to listen when the button is clicked.
             */
            "pn-button-dropdown": LocalJSX.PnButtonDropdown & JSXBase.HTMLAttributes<HTMLPnButtonDropdownElement>;
            /**
             * The card component is more than just a navigational element.
             * It is a flexible component that can be used as a product item, a clickable link card, etc...
             * Setting the `href` prop will transform the entire `pn-card` into a clickable element.
             * If you need content to be interactable inside the card, do not use the `href` prop.
             */
            "pn-card": LocalJSX.PnCard & JSXBase.HTMLAttributes<HTMLPnCardElement>;
            /**
             * The `pn-checkbox` is built with a native `input[type="checkbox"]` in the background.
             * This means you can use native events to listen to the changes.
             * @nativeChange Use the `change` event to listen when the checkbox state is being toggled.
             */
            "pn-checkbox": LocalJSX.PnCheckbox & JSXBase.HTMLAttributes<HTMLPnCheckboxElement>;
            /**
             * The `pn-choice-chip` is built with a native `input[type="checkbox|radio"]` in the background.
             * This means you can use native events to listen to the changes.
             * @nativeChange Use the `change` event to listen when the choice chip state is being toggled. Works for both checkbox/radio variant.
             */
            "pn-choice-chip": LocalJSX.PnChoiceChip & JSXBase.HTMLAttributes<HTMLPnChoiceChipElement>;
            /**
             * The `pn-counter` is an input with a button on each side that can be used to increase and decrease the input value.
             * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
             * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
             */
            "pn-counter": LocalJSX.PnCounter & JSXBase.HTMLAttributes<HTMLPnCounterElement>;
            /**
             * The date picker allows a single or a range of dates to be selected.
             * Based on the `format` prop, separators will automatically be added if you type the date.
             * You can navigate the calendar grid with your keyboard.
             * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
             * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
             */
            "pn-date-picker": LocalJSX.PnDatePicker & JSXBase.HTMLAttributes<HTMLPnDatePickerElement>;
            /**
             * The fielset is a wrapper to give context and information about inputs. Most commonly, a set of radio/checkboxes.
             * However, you may include any type of input such as textareas, toggles and selects.
             */
            "pn-fieldset": LocalJSX.PnFieldset & JSXBase.HTMLAttributes<HTMLPnFieldsetElement>;
            /**
             * Users can drop files directly into the upload area of the component
             * or simply click on it to open their native file explorer.
             * @nativeChange Use the `change` event to listen when the input receives files.
             * @nativeCancel The `cancel` event lets you know the user canceled their selection.
             * Either via clicking on the "Cancel" button or pressing `ESC`.
             */
            "pn-file-upload": LocalJSX.PnFileUpload & JSXBase.HTMLAttributes<HTMLPnFileUploadElement>;
            /**
             * The default market and language is SE/en.
             * Make sure you set the market **and** language prop.
             * Example: Setting the `language` prop `da` will not display anything, as `da` does not exist on the `SE` market.
             * @deprecated This component has been replaced with the {@link https://portal.postnord.com/web-components/?path=/docs/external-components-pn-footer-nav--docs pn-footer-nav}.
             */
            "pn-footer": LocalJSX.PnFooter & JSXBase.HTMLAttributes<HTMLPnFooterElement>;
            "pn-header": LocalJSX.PnHeader & JSXBase.HTMLAttributes<HTMLPnHeaderElement>;
            /**
             * The `pn-icon` is a wrapper for an SVG string.
             * While its built with PostNords specific icon dimensions in mind (24x24px), you can use any SVG content in this component.
             * As long as its 3x3 in size, there should be no problem.
             * The color feature will not overwrite the color of flags.
             */
            "pn-icon": LocalJSX.PnIcon & JSXBase.HTMLAttributes<HTMLPnIconElement>;
            "pn-illustration": LocalJSX.PnIllustration & JSXBase.HTMLAttributes<HTMLPnIllustrationElement>;
            /**
             * The `pn-input` is a regular `input` but styled. This means you can use native events to listen to the changes.
             * Always use the `label` prop to make sure the input is accessible.
             * @nativeInput Use the `input` event to listen to content being modified by the user. It is emitted everytime a user writes or removes content in the input.
             * @nativeChange The `change` event is emitted when the input loses focus, the user clicks `Enter` or makes a selection (such as auto complete or suggestions).
             */
            "pn-input": LocalJSX.PnInput & JSXBase.HTMLAttributes<HTMLPnInputElement>;
            /**
             * Present content in a modal that overlays everything on the current page.
             * Use the prop `open` to toggle the visiblity.
             * Use the event `close` to determine when the modal is being closed by the user.
             */
            "pn-modal": LocalJSX.PnModal & JSXBase.HTMLAttributes<HTMLPnModalElement>;
            /**
             * The `pn-multiselect` gets its options via javascript.
             * Native HTML does not accept arrays of objects. Most frameworks solves this automatically (Vue, react, etc...),
             * but keep this in mind if you use this component outside of a framework environment.
             * @nativeChange The `pn-multiselect` is built with `input[type=checkbox]` elements, so the `change` event works. However, we recommend the customEvents described above.
             * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-input-multiselect--docs#pn-multiselect%20(options) Options documentation}
             */
            "pn-multiselect": LocalJSX.PnMultiselect & JSXBase.HTMLAttributes<HTMLPnMultiselectElement>;
            "pn-ocr-search": LocalJSX.PnOcrSearch & JSXBase.HTMLAttributes<HTMLPnOcrSearchElement>;
            /**
             * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
             * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
             */
            "pn-page-nav": LocalJSX.PnPageNav & JSXBase.HTMLAttributes<HTMLPnPageNavElement>;
            /**
             * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
             * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
             */
            "pn-page-nav-dropdown-item": LocalJSX.PnPageNavDropdownItem & JSXBase.HTMLAttributes<HTMLPnPageNavDropdownItemElement>;
            /**
             * @deprecated This component will be removed in v8. Please use the `pn-tablist` instead.
             * @see {@link https://portal.postnord.com/web-components/?path=/docs/components-navigation-tablist--docs} Use `pn-tablist` instead.
             */
            "pn-page-nav-item": LocalJSX.PnPageNavItem & JSXBase.HTMLAttributes<HTMLPnPageNavItemElement>;
            /**
             * Accessible pagination needs each item to link to a different part of the document.
             * This means that you must `preventDefault` on the `MouseEvent` emitted from the `pageSelected` event if you have a SPA.
             * If you set a `page` value that is higher than `pages`, the component will automatically lower it to the `pages` value.
             */
            "pn-pagination": LocalJSX.PnPagination & JSXBase.HTMLAttributes<HTMLPnPaginationElement>;
            "pn-progress-bar": LocalJSX.PnProgressBar & JSXBase.HTMLAttributes<HTMLPnProgressBarElement>;
            "pn-progress-indicator": LocalJSX.PnProgressIndicator & JSXBase.HTMLAttributes<HTMLPnProgressIndicatorElement>;
            "pn-progress-indicator-step": LocalJSX.PnProgressIndicatorStep & JSXBase.HTMLAttributes<HTMLPnProgressIndicatorStepElement>;
            /**
             * The `pn-progress-stepper` is used to visualize the users progress through a flow (checkout/survey, etc...).
             */
            "pn-progress-stepper": LocalJSX.PnProgressStepper & JSXBase.HTMLAttributes<HTMLPnProgressStepperElement>;
            /**
             * The `pn-radio-button` is built with a native `input[type="radio"]` in the background.
             * This means you can use native events to listen to the changes.
             * @nativeChange Use the `change` event to listen when the radio state is being changed.
             */
            "pn-radio-button": LocalJSX.PnRadioButton & JSXBase.HTMLAttributes<HTMLPnRadioButtonElement>;
            /**
             * There are no events or features other than the `icon`, `small` and `language` prop.
             * Our rule is to not have disabled buttons.
             * However, this component is an exception for a very specific use case regarding portal users.
             */
            "pn-read-only-button": LocalJSX.PnReadOnlyButton & JSXBase.HTMLAttributes<HTMLPnReadOnlyButtonElement>;
            "pn-search-field": LocalJSX.PnSearchField & JSXBase.HTMLAttributes<HTMLPnSearchFieldElement>;
            /**
             * The `pn-segment` is built with a native `input[type="radio"]` in the background.
             * Do not listen to events on the `pn-segment`, but on the `pn-segmented-control` instead.
             */
            "pn-segment": LocalJSX.PnSegment & JSXBase.HTMLAttributes<HTMLPnSegmentElement>;
            /**
             * The `pn-segmented-control` and `pn-segmented` is built with native `input[type="radio"]` in the background.
             * This means you can use native events to listen to the changes.
             * @nativeChange Use the `change` event to listen when the segment state is being changed.
             */
            "pn-segmented-control": LocalJSX.PnSegmentedControl & JSXBase.HTMLAttributes<HTMLPnSegmentedControlElement>;
            /**
             * The `pn-select` uses a native `select` element under the hood.
             * Use the slot to include `option` elements.
             * Just like a regular `select`, you can use the `selected` prop on the nested option elements to preselect an option.
             * @nativeChange Use the `change` event to listen to changes on the select element.
             */
            "pn-select": LocalJSX.PnSelect & JSXBase.HTMLAttributes<HTMLPnSelectElement>;
            "pn-spinner": LocalJSX.PnSpinner & JSXBase.HTMLAttributes<HTMLPnSpinnerElement>;
            "pn-tab": LocalJSX.PnTab & JSXBase.HTMLAttributes<HTMLPnTabElement>;
            /**
             * The `pn-table` component is just a wrapper for your HTML table element.
             * You need to create the markup, but the component will deal with the styling.
             * We have a built in class for divs inside table colums called `column-wrapper`.
             * This will line up your content and provide a grid gap.
             */
            "pn-table": LocalJSX.PnTable & JSXBase.HTMLAttributes<HTMLPnTableElement>;
            "pn-tablist": LocalJSX.PnTablist & JSXBase.HTMLAttributes<HTMLPnTablistElement>;
            /**
             * The `pn-tag` is a non-interactive visual marker designed to emphasize important aspects of an item, such as its status.
             */
            "pn-tag": LocalJSX.PnTag & JSXBase.HTMLAttributes<HTMLPnTagElement>;
            /**
             * The `pn-text-link` is a styled `a` element with some extra functionality built in. Such as `icon` and `light` support.
             */
            "pn-text-link": LocalJSX.PnTextLink & JSXBase.HTMLAttributes<HTMLPnTextLinkElement>;
            /**
             * The `pn-textarea` is built with a native `textarea`.
             * This means you can use native events to listen to the input.
             * @nativeInput Use the `input` event to listen to content being modified by the user.
             */
            "pn-textarea": LocalJSX.PnTextarea & JSXBase.HTMLAttributes<HTMLPnTextareaElement>;
            /**
             * The `pn-tile` is a navigational element that is intended to be accompanied by an illustration.
             * It is very important that you use the `label` and `url`. This component renders an `a` element if the URL prop is set,
             * so you do not need to wrap or nest the tile in another `a` element. Doing so makes the component inaccessible.
             */
            "pn-tile": LocalJSX.PnTile & JSXBase.HTMLAttributes<HTMLPnTileElement>;
            /**
             * This component is able to fill many roles of a classic toast.
             * It has 4 different colors, a temporary state, hide button, icon and illustration support.
             * The `pn-toast` will expand to its parent containers full width.
             * Either limit the parent width or set a CSS rule to your specific width if needed.
             */
            "pn-toast": LocalJSX.PnToast & JSXBase.HTMLAttributes<HTMLPnToastElement>;
            /**
             * The `pn-toggle-switch` is built with a native `input[type="checkbox"]` in the background.
             * This means you can use native events to listen to the changes.
             * @nativeChange Use the `change` event to listen when the switch state is being toggled.
             */
            "pn-toggle-switch": LocalJSX.PnToggleSwitch & JSXBase.HTMLAttributes<HTMLPnToggleSwitchElement>;
            /**
             * The `pn-tooltip` can display slotted HTML content or a text `string` with the `tooltip` prop.
             * Remember that the component is techincally a `button` element, don't put any HTML content that would be out of place in a regular button
             * (no headlines, other input elements, etc...).
             */
            "pn-tooltip": LocalJSX.PnTooltip & JSXBase.HTMLAttributes<HTMLPnTooltipElement>;
            /**
             * Check the delivery date for letters, newspapers and direct mail that are distributed every second day.
             */
            "pn-zipcode-search": LocalJSX.PnZipcodeSearch & JSXBase.HTMLAttributes<HTMLPnZipcodeSearchElement>;
        }
    }
}
