import { PnButtonAppearance, PnButtonVariant } from "../../../index";
/**
 * The open/closing of the dropdown is handled by the component itself.
 *
 * @nativeClick Use the `click` event to listen when the button is clicked.
 */
export declare class PnButtonDropdown {
    id: string;
    focusableElements: Array<HTMLLinkElement | HTMLButtonElement | HTMLInputElement>;
    container: HTMLDivElement;
    dropdownButtonId: string;
    dropdownContentId: string;
    hostElement: HTMLElement;
    right: boolean;
    top: boolean;
    /** The required label on the button. */
    label: string;
    /** The optional SVG content of the icon you want. */
    icon?: string;
    /** Select between `light` and `warning`. */
    appearance?: PnButtonAppearance;
    /** Select between `outlined` and `borderless`. */
    variant?: PnButtonVariant;
    /** Smaller button. */
    small: boolean;
    /** Tooltip (required for Icon Only). */
    tooltip: string;
    /** Open/close the dropdown without user interaction. */
    open: boolean;
    openHandler(): void;
    componentDidLoad(): void;
    getRect(element: HTMLElement): DOMRect;
    globalHandler: (e: KeyboardEvent) => void;
    toggleDropdown(): void;
    toggle: () => void;
    render(): any;
}
