import { PnLanguages } from "../../../globals/types";
/**
 * There are no events or features other than the `icon`, `small` and `language` prop.
 *
 * Our rule is to not have disabled buttons.
 * However, this component is an exception for a very specific use case regarding portal users.
 */
export declare class PnReadOnlyButton {
    hostElement: HTMLElement;
    readOnlyModeText: string;
    tooltipOpen: boolean;
    tooltipEl: HTMLDivElement;
    tooltipDx: string;
    /** The SVG content of the icon you want. */
    icon?: string;
    /** Icon on the left side instead of on the right. */
    leftIcon: boolean;
    /** If you're using a button with only an icon, button text is still REQUIRED for the tooltip. */
    iconOnly: boolean;
    /** Smaller button. */
    small: boolean;
    /** Set the language manually. */
    language?: PnLanguages;
    setReadOnlyModeText(): void;
    componentWillLoad(): Promise<void>;
    componentDidLoad(): void;
    openHandler(): void;
    initTooltip(): void;
    setTooltipOffset(): void;
    checkTooltipPosition(): void;
    getClassNames(): string;
    render(): any;
}
