/** The `pn-tag` is a non-interactive visual marker designed to emphasize important aspects of an item, such as its status. */
export declare class PnTag {
    /** The label of the tag. */
    label: string;
    /**
     * Select icon from out `pn-design-assets` list. Works with any SVG content.
     *
     * **Please note**: Can not be used with the `xsmall` prop due to the small size.
     *
     * @see {@link https://portal.postnord.com/web-components/?path=/docs/docs-assets--docs Get started with PostNord assets.}
     */
    icon?: string;
    /** Set tag appearance: `discrete`, `positive`, `warning` & `error`. @category Visual */
    appearance?: '' | 'discrete' | 'positive' | 'warning' | 'error';
    /**
     * Set darker background-color on the tag.
     *
     * This is intended for better tag visibility on colored background.
     *
     * @category Visual
     * @deprecated Will be removed in v8.0.0
     */
    dark?: boolean;
    /** Set larger tag. @category Size */
    large?: boolean;
    /** Set smaller tag. @category Size */
    small?: boolean;
    /** Set extra small tag. @category Size */
    xsmall?: boolean;
    componentWillRender(): void;
    showIcon(): boolean;
    render(): any;
}
