import { EventEmitter } from '../../../stencil-public-runtime';
/**
 * Present content in a modal that overlays everything on the current page.
 * Use the prop `open` to toggle the visiblity.
 * Use the event `close` to determine when the modal is being closed by the user.
 *
 * @slot buttons - Place buttons inside the modal at the bottom.
 */
export declare class PnModal {
    mo: MutationObserver;
    untabbable: HTMLElement[];
    elToFocus: HTMLElement;
    handleFocus: any;
    handleBlur: any;
    handleEsc: any;
    handleGlobalClick: any;
    hostElement: HTMLElement;
    focusableEls: HTMLElement[];
    /** Bind to this property if you want to control the visibility of the modal from your own data. */
    open: boolean;
    handleOpen(): void;
    /** Event fired when the modal is closed, either by clicking on the dark background or by clicking on the close button. */
    close: EventEmitter<boolean>;
    componentDidLoad(): void;
    toggleOpen(state?: boolean): void;
    setFocusableElements(): void;
    addEventListeners(): void;
    removeEventListeners(): void;
    focusHandler(e: FocusEvent): void;
    blurHandler(e: FocusEvent): void;
    escHandler({ code }: {
        code: any;
    }): void;
    globalClickHandler(e: PointerEvent): void;
    render(): any;
}
