import type { PnLanguages, PnSteps, PnStepProps } from "../../../globals/types";
/**
 * The `pn-progress-stepper` is used to visualize the users progress through a flow (checkout/survey, etc...).
 **/
export declare class PnProgressStepper {
    id: string;
    idLabel: string;
    idBar: string;
    minStep: 1;
    maxStep: 7;
    hostElement: HTMLElement;
    /** Percentage calculated with currentStep / totalSteps. */
    progressValue: number;
    /** Set custom label for the stepper, recommended default label is "Step". */
    label?: string;
    /** Set total amount of steps, maximum `7` is allowed. */
    totalSteps: PnSteps;
    /** The current step of the progress stepper. */
    currentStep: PnSteps;
    /** You can add a custom optional string to the label if you need a name for the current step. */
    stepName?: string;
    /** Set a custom HTML id on the progress stepper element to associate progress bar with label. */
    progressStepperId?: string;
    /**
     * Set the language manually, only use this prop if the pnTopbar is not loaded.
     * Will not overwrite the `label` prop if used.
     **/
    language?: PnLanguages;
    validateCurrentStep(step: PnSteps): void;
    validateTotalSteps(step: PnSteps): void;
    watchLanguage(): void;
    watchId(): void;
    componentWillLoad(): Promise<void>;
    componentWillRender(): void;
    hasCustomLabel(): boolean;
    validate(step: PnSteps, prop: PnStepProps): void;
    calculateProgress(): void;
    render(): any;
}
