/**
 * The `pn-tooltip` can display slotted HTML content or a text `string` with the `tooltip` prop.
 *
 * Remember that the component is techincally a `button` element, don't put any HTML content that would be out of place in a regular button
 * (no headlines, other input elements, etc...).
 */
export declare class PnTooltip {
    content: HTMLDivElement;
    button: HTMLButtonElement;
    openEvents: string[];
    closeEvents: string[];
    eventListeners: string[];
    timeout: NodeJS.Timeout;
    hostElement: HTMLElement;
    downwards: boolean;
    open: boolean;
    deltaX: string | number;
    /** Apply the warning color and change the icon to `!`. */
    warning: boolean;
    /** Apply the light color if you use a dark background. */
    light: boolean;
    /** Overrides the slotted content to create a small tooltip instead. */
    tooltip?: string;
    openHandler(): void;
    componentDidLoad(): void;
    private setTransform;
    private getSymbol;
    private checkPosition;
    private initTooltip;
    private toggleTooltip;
    render(): any;
}
