/**
 * The `pn-choice-chip` is built with a native `input[type="checkbox|radio"]` in the background.
 * This means you can use native events to listen to the changes.
 *
 * @nativeChange Use the `change` event to listen when the choice chip state is being toggled. Works for both checkbox/radio variant.
 */
export declare class PnChoiceChip {
    hostElement: HTMLElement;
    moving: boolean;
    /** The choice chip label */
    label: string;
    /** This will be emitted on change and input */
    value: string;
    /** The name of the checkbox group */
    name?: string;
    /** Precheck the choice chip */
    checked?: boolean;
    /** Make the choice chip a radio */
    radio: boolean;
    /** A unique HTML id */
    choiceid: string;
    /** Include an icon */
    icon?: string;
    /** Set the choice chip as required. @category State */
    required: boolean;
    /** Disable the choice chip. @category State */
    disabled: boolean;
    /** Set the size to small. @category Size */
    small: boolean;
    /** Set the size to large. @category Size */
    large: boolean;
    render(): any;
}
