import { EventEmitter } from '../../../../stencil-public-runtime';
/**
 * The `pn-segment` is built with a native `input[type="radio"]` in the background.
 * Do not listen to events on the `pn-segment`, but on the `pn-segmented-control` instead.
 */
export declare class PnSegment {
    id: string;
    hostElement: HTMLElement;
    /** The segment label, same as the slot. */
    label?: string;
    /** The segment controller name. */
    name: string;
    /** The segment value. */
    value: string;
    /** Set the segment as selected. Used by the `pn-segmented-control`. **Do not use manually**. @hide true */
    selected: boolean;
    /** A unique HTML id. */
    segmentid: string;
    /** The SVG content of the icon you want. */
    icon?: string;
    /** Disable the segment. */
    disabled: boolean;
    /** This event is used by the `pn-segmented-control` component. Do not use manually. */
    segmentHover: EventEmitter<MouseEvent>;
    handleHover(mouse: MouseEvent): void;
    render(): any;
}
