import { PnLanguages } from "../../../globals/types";
/**
 * @slot breadcrumb - This slot is reserved for a `pn-text-link` or another complex breadcrumb links structure.
 * Do not use this slot and the `go-back-href` prop at the same time.
 * @slot buttons - This slot is used to align multiple `pn-button` elements. However, we recommend a single button.
 * @slot menu - This slot is reserved for a `pn-tablist`.
 * This slot allows you to use the `href` prop on `pn-tab`, turning them into links instead of buttons.
 */
export declare class PnHeader {
    mo: MutationObserver;
    hasBreadcrumb: boolean;
    hasMenu: boolean;
    hasButtons: boolean;
    hostElement: HTMLElement;
    /** Heading text. */
    heading: string;
    /** Set a inner container max-width, any width CSS value is accepted.  */
    maxWidth?: string;
    setMaxWidth(): void;
    /** The href for the go back link. If this is provided a button be displayed. */
    goBackHref?: string;
    /** The text for the back link. */
    goBackText?: string;
    /** Set the language manually, only use this prop if the pnTopbar is not loaded. Supported: sv, en, da, fi and no. */
    language?: PnLanguages;
    setLanguage(): void;
    goBackTextTranslated: string;
    componentWillLoad(): Promise<void>;
    checkSlots(): void;
    showBreadcrumb(): boolean;
    render(): any;
}
