import { EventEmitter } from '../../../stencil-public-runtime';
import type { PnLanguages } from "../../../globals/types";
/**
 * @slot menu - Can only be used inside of a `pn-header`. Allows the `href` attribute on the `pn-tab` when active.
 */
export declare class PnTablist {
    mo: MutationObserver;
    isMenu: boolean;
    isTabHovered: boolean;
    tabListEl: HTMLElement;
    lineActive: HTMLDivElement;
    lineHovered: HTMLDivElement;
    tabElement: HTMLPnTabElement;
    hostElement: HTMLElement;
    /** Display the scrolling arrows */
    showScrollArrows: boolean;
    /** Display the scroll arrow to the left */
    arrowLeft: boolean;
    /** Display the scroll arrow to the right */
    arrowRight: boolean;
    /** Give the tablist a name for screenreaders */
    label: string;
    /** The value of the tab that is currently active, each `<pn-tab value="example-value">` also expects a unique value */
    value: string;
    /** Make the tablist smaller */
    small?: boolean;
    /** Icons are stacked vertically instead of the default rows */
    stackedicons: boolean;
    /** Manually set the language. */
    language?: PnLanguages;
    /**
     * This will emit when a tab is changed. The detail property of the event will contain the value of the selected tab.
     * This is the event and value you listen to when you toggle the visibility among your tabpanels.
     **/
    tabchange: EventEmitter<string>;
    setValue(): void;
    scrollHandler(): void;
    setActiveTabHandler({ detail }: {
        detail: any;
    }): void;
    rerender(): void;
    handleEnter(e: {
        target: HTMLPnTabElement;
    }): void;
    handleLeave(): void;
    componentWillLoad(): Promise<void>;
    componentDidLoad(): void;
    componentDidRender(): void;
    getRect(element: HTMLElement | HTMLPnTablistElement): DOMRect;
    activateTab(element: HTMLPnTabElement): void;
    styleLines(element: HTMLElement, active?: boolean): void;
    scrollIndicators(): void;
    scroll({ right }?: {
        right?: boolean;
    }): void;
    translate(prop: string): string;
    render(): any;
}
