import { EventEmitter } from '../../../../stencil-public-runtime';
export declare class PnTab {
    tag: string;
    hostElement: HTMLElement;
    /** Set a label for the tab. */
    label: string;
    /** This is the value that will be matched with `pn-tablist` value. (required) */
    value: string;
    /** Turns the tab from a `button` to an `a` element, but only if the `pn-tablist` is inside a `pn-header`. */
    href?: string;
    /** The SVG content of the icon you want to display */
    icon?: string;
    /** Use the ID of the container that this tab controls.  */
    ariacontrols?: string;
    /** Tab ID, use if you want to have the tab container be `aria-labelledby` by this tab. */
    tabid?: string;
    /** Is set by `pn-tablist`, don't use this prop. @hide true */
    activeTab: string;
    /** Used by `pn-tab` to communicate with `pn-tablist`. Emits the selected tab value and element. */
    setActiveTab: EventEmitter<{
        val: string;
        el: HTMLPnTabElement;
    }>;
    setActiveTabHandler({ click, element }?: {
        click?: boolean;
        element?: HTMLPnTabElement;
    }): void;
    /** Used by `pn-tab` to communicate with `pn-tablist`. Emits when the tab gets focus. */
    tabEnter: EventEmitter<MouseEvent | FocusEvent>;
    triggerEnter(event: MouseEvent | FocusEvent): void;
    /** Used by `pn-tab` to communicate with `pn-tablist`. Emits when the tab is blured.  */
    tabLeave: EventEmitter<MouseEvent | FocusEvent>;
    triggerLeave(event: MouseEvent | FocusEvent): void;
    componentWillLoad(): void;
    componentDidUpdate(): void;
    componentDidLoad(): void;
    arrowKeyNav(event: KeyboardEvent): void;
    isActive(): boolean;
    tabTag(): void;
    renderProperties(): {
        href: string;
        'aria-current': string;
        tabindex?: undefined;
        type?: undefined;
        role?: undefined;
        'aria-selected'?: undefined;
        'aria-controls'?: undefined;
    } | {
        tabindex: number;
        type: string;
        role: string;
        'aria-selected': string;
        'aria-controls': string;
        href?: undefined;
        'aria-current'?: undefined;
    };
    handleClick(e: MouseEvent): void;
    render(): any;
}
