/** The `pn-text-link` is a styled `a` element with some extra functionality built in. Such as `icon` and `light` support.  */
export declare class PnTextLink {
    hostElement: HTMLElement;
    /** The link text. */
    label?: string;
    /** The URL string. */
    href: string;
    /** Use the light version of the link. @category Visual */
    light: boolean;
    /** SVG content of the icon. @category Visual */
    icon?: string;
    /** Align the icon on the left. @category Visual */
    leftIcon: boolean;
    /** Treat the link as a download link. @category Link attributes */
    download?: string;
    /** Set the hreflang of the URL destination. @category Link attributes */
    hreflang?: string;
    /** Link media. @category Link attributes */
    media?: string;
    /** Set referrerpolicy on the link. @category Link attributes */
    referrerpolicy?: ReferrerPolicy;
    /** Set the rel of the link. @category Link attributes */
    rel: string;
    /** Set the target of the link. @category Link attributes */
    target?: string;
    /** Set a unique html ID of the a element. @category Link attributes */
    linkid?: string;
    render(): any;
}
