import { EventEmitter } from '../../../stencil-public-runtime';
import { translations } from './translations';
import { PnZipCodeSearchLanguages } from "../../../index";
/** Check the delivery date for letters, newspapers and direct mail that are distributed every second day. */
export declare class PnZipcodeSearch {
    /** This language property will update when pnTopbar loads */
    searchId: string;
    hostElement: HTMLElement;
    validZipCode?: string;
    loading: boolean;
    showResult: boolean;
    zipCodeSearchResult: {
        delivery: string;
        upcoming: string;
        city: string;
        postalCode: string;
    };
    error: boolean;
    errorMessage: keyof typeof translations;
    /** The `language` property will be prioritized before the pnTopbar language. */
    language?: PnZipCodeSearchLanguages;
    /** Set a pre initialized value. */
    value?: string;
    /** Event fired when search has result */
    searchsuccessful: EventEmitter<boolean>;
    componentWillLoad(): Promise<void>;
    private translation;
    private handleSearch;
    private zipCodeSearch;
    private validateZipCode;
    private renderSearchResult;
    private renderErrorMessage;
    render(): any;
}
